︠85799431-f344-4144-87ab-f02c56ab7466i︠
%html
<h1 style="text-align: center;">Algebraic number theory and related topics</h1>
<h2 style="text-align: center;">at RIMS, 2010/12/6-10</h2>
<h1 style="text-align: center;">Sage for Number Theorists</h1>
<h2 style="text-align: center;">Iwao KIMURA (University of Toyama)</h2>
<p>&nbsp;</p>
<p style="text-align: center;">This is a Sage notebook which I gave a demonstration of doing math (number theory) by Sage.<br /><br /></p>
<h2 style="font-size: 1.5em; text-align: center;">As a calculator</h2>

︡75b197b2-143a-4aec-ae10-db2b8af16455︡{"html": "<h1 style=\"text-align: center;\">Algebraic number theory and related topics</h1>\n<h2 style=\"text-align: center;\">at RIMS, 2010/12/6-10</h2>\n<h1 style=\"text-align: center;\">Sage for Number Theorists</h1>\n<h2 style=\"text-align: center;\">Iwao KIMURA (University of Toyama)</h2>\n<p>&nbsp;</p>\n<p style=\"text-align: center;\">This is a Sage notebook which I gave a demonstration of doing math (number theory) by Sage.<br /><br /></p>\n<h2 style=\"font-size: 1.5em; text-align: center;\">As a calculator</h2>"}︡
︠126cd62b-bfe5-4280-847b-c42988ef87af︠
1+1  # as a calculator. Shift + Enter == Evaluate
︡13820eba-e2c1-4bba-b802-940e4c490a51︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}2</span>"}︡
︠d8cab6e6-4344-4375-bde1-9dd255990c1a︠
factorial(100) # long integer
︡e57a9d1c-db99-4797-93ae-0060644a8850︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}93326215443944152681699238856266700490715968264381621468592963895217599993229915608941463976156518286253697920827223758251185210916864000000000000000000000000</span>"}︡
︠2032fafd-e8f0-4da2-a524-b37bfe575fe2︠
factor(2^2^5+1) # prime factorization of the 5-th Fermat number (composite number).
︡97a4b77b-4ef4-4f6f-b41e-ce5b7328e757︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}641 \\cdot 6700417</span>"}︡
︠99f4dac7-8e00-4129-b9b2-d4d831b26fda︠
a = 2 # variable.
︡db1d9004-4764-4a40-bb93-52442c7133af︡︡
︠d4c7a536-ba7e-4f60-9c9b-e6f72aa101df︠
a
︡921bab30-5c2e-4d53-b2d6-e75d0e5e80d9︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}2</span>"}︡
︠132e4c81-d52a-4fd2-8990-246dd89bb60e︠
a = "2" # variable does not have a type (values have.)
︡a1518910-67e9-4874-b9d7-cc976f79c004︡︡
︠6144fcc4-5447-41ea-b7a3-54a54b70173f︠
a == 2
︡a59d2e82-1531-4d26-b757-ec1788420618︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}{\\rm False}</span>"}︡
︠fb93dd4f-4743-42a8-b017-f0972ea2564b︠
a == "2"
︡b752377e-bc82-4a52-aef8-e67d4b68ca79︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}{\\rm True}</span>"}︡
︠b4dab3db-f365-4223-9b26-8d6d9c8a0ba5︠
type(a) # inspect the type of value contained in a
︡41fe002e-a7ce-48be-a16a-c18c2a8534de︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\hbox{ < type 'str' > }</span>"}︡
︠89d1f39c-f059-4235-9264-7b960e4a3ca3︠
type(2)
︡96c0ccee-506e-4c26-91fa-333cbd86556a︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\hbox{ < type 'sage.rings.integer.Integer' > }</span>"}︡
︠c5871dc6-d31b-44bd-88a9-c6d9280771ea︠
a = [2]
︡1dc06014-65b8-43b7-a65c-49468d423165︡︡
︠e910e9ce-a8ce-4153-8e4c-b3758526eaef︠
type(a)
︡568c1316-348a-4971-8136-d419e17d990b︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\hbox{ < type 'list' > }</span>"}︡
︠ac9c4785-a2a9-4098-b94b-800c3cbd7bf4︠
parent(2)
︡0e330590-830a-4287-af11-ae659bed86fb︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Bold{Z}</span>"}︡
︠d0f4bd03-6b8c-4133-96d3-d69acf0fb2a5︠
parent('2')
︡b711df59-e78b-4b8c-ad3f-746ca9040447︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\hbox{ < type 'str' > }</span>"}︡
︠3fb3e6e0-8cba-4e7c-9e02-a2cf1672930ai︠
%html
<h2 style="text-align: center;">2D Plotting</h2>

︡d4d90708-6101-4c91-b79e-ac2af85ee176︡{"html": "<h2 style=\"text-align: center;\">2D Plotting</h2>"}︡
︠eb0a6cb5-9875-4030-9bc7-0910bb704d4b︠
plot(sin(1/x), (0,pi))
︡4bc83114-93b7-4580-a423-80ef20e9f6ec︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠3b9e5c6f-abb2-4222-9fbb-c3ec960b47af︠
def zeta_plot(x):
    """
    parametric plot of Riemann zeta function on the critical line.
    1/2 + t*I, 0<= t <= x.
    """
    t=var('t')
    parametric_plot((lambda t: real(zeta(1/2+t*I)),
                     lambda t: imaginary(zeta(1/2+t*I))), 
                    (t, 0, x)).show()
︡279e935e-5fba-4837-a397-d415735ca4a3︡︡
︠2ffcbae4-e4e1-4956-8526-43dbe719e7c7︠
zeta_plot(50.0)
︡92d95f91-cc56-40e3-a5fc-b6c58b73f736︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠bc53cf52-5348-47df-84ac-30c5dec30ec8i︠
%html
<h2 style="text-align: center;">Interactive plotting</h2>

︡8488750e-9cae-4a4c-84ce-33d68d95bc51︡{"html": "<h2 style=\"text-align: center;\">Interactive plotting</h2>"}︡
︠750a83bc-9201-4bce-8d2c-1c1153ccb1c8︠
A = matrix([[1,1],[-1,1]])
D = [vector([0,0]), vector([1,0])]

@interact
def f(A = matrix([[1,1],[-1,1]]), D = '[[0,0],[1,0]]', k=(3..17)):
    print "Det = ", A.det()
    D = matrix(eval(D)).rows()
    def Dn(k):
        ans = []
        for d in Tuples(D, k):
            s = sum(A^n*d[n] for n in range(k))
            ans.append(s)
        return ans
    
    G = points([v.list() for v in Dn(k)])
    show(G, frame=True, axes=False)
︡33cda12a-b0e3-4f79-ab87-5c34f6d5d29f︡︡
︠987fbb38-7242-4dc5-ae8d-5e133b3f8e39i︠
%html
<h2 style="text-align: center;">3D graphic</h2>

︡c15e4449-294a-4b3a-9795-f2b2c656af16︡{"html": "<h2 style=\"text-align: center;\">3D graphic</h2>"}︡
︠a48893d7-62f5-4385-a546-a8a7068e6d45︠
t = Tachyon(xres=640,yres=480, camera_center=(5,0,0))
t.light((4,3,2), 0.2, (1,1,1))
t.texture('t2', ambient=0.1, diffuse=0.9, specular=0.5, opacity=0.8, color=(1,0,
0))
t.texture('t3', ambient=0.1, diffuse=0.9, specular=0.5, opacity=0.7, color=(0,1,
0))
t.texture('t4', ambient=0.1, diffuse=0.9, specular=0.5, opacity=0.6, color=(0,0,
1))
t.texture('t5', ambient=0.1, diffuse=0.9, specular=0.5, opacity=0.9, color=(0,1,
1))
for k in range(2,6):
    t.sphere((0,0.25*k, (0.25*k)^2), 0.4, 't%s'%(k))
t.show()
︡08b7a7e2-dd2f-4432-a95f-97d835103dac︡︡
︠c04dbc2e-243b-4b21-8b28-3a0bf1f28960i︠
%html
<h2 style="text-align: center;">Taken from somewhere...</h2>
<p>&nbsp;</p>
<p>There are a lot of good looking pictures or plotting drawn by Sage.</p>

︡d8154ea7-015e-44d7-9287-13995768f8d0︡{"html": "<h2 style=\"text-align: center;\">Taken from somewhere...</h2>\n<p>&nbsp;</p>\n<p>There are a lot of good looking pictures or plotting drawn by Sage.</p>"}︡
︠7e41a1ba-1104-44bf-bd83-875716a8f5d6︠
t = Tachyon(xres=1024,yres=768, camera_center=(3,0.2,0), raydepth=8)
t.light((4,3,2), 0.2, (1,1,1))
t.texture('t0', ambient=0.1, diffuse=0.9, specular=0.5, opacity=1.0, color=(1.0,0,0))
t.texture('t1', ambient=0.1, diffuse=0.9, specular=0.3, opacity=1.0, color=(0,1.0,0))
t.texture('t2', ambient=0.2,diffuse=0.7, specular=0.5, opacity=0.7, color=(0,0,1.0))
t.texture('white', color=(1,1,1))
t.plane((0,0,-1), (0,0,1), 'white')
t.plane((0,-20,0), (0,1,0), 'white')
t.plane((-20,0,0), (1,0,0), 'white')
k=0
for i in srange(-1,2,0.05):
    k += 1
    t.sphere((i, i^2 - 0.5*i, 0.5*i^3), 0.1, 't%s'%(k%3))
    t.cylinder((0,0,0), (0,0,1), 0.05,'t1') 

t.show()
︡a703a8f2-2841-48b6-a267-10311a0a17c6︡︡
︠8bd12740-3d23-44b9-b7d3-ce982f70570ai︠
%html
<h2 style="text-align: center;">Another 3D plotting...</h2>
<p>&nbsp;</p>
<p>3D interactive graphics are drawn by JMol (Java applet).</p>

︡88272887-7837-4f91-a875-f83b132c7767︡{"html": "<h2 style=\"text-align: center;\">Another 3D plotting...</h2>\n<p>&nbsp;</p>\n<p>3D interactive graphics are drawn by JMol (Java applet).</p>"}︡
︠e04cabde-4d11-4d4f-9de7-8eb44ba45689︠
u, v = var('u,v')
fx = (3+sin(v)+cos(u))*cos(2*v)
fy = (3+sin(v)+cos(u))*sin(2*v)
fz = sin(u)+2*cos(v)
parametric_plot3d([fx, fy, fz], (u, 0, 2*pi), (v, 0, 2*pi), frame=False, color="red")
︡fc64e9c3-3fc1-464e-9d34-548650b940dd︡︡
︠b9ec43d2-67bd-480a-86b6-6696bb387594i︠
%html
<h2 style="text-align: center;">Tiny examples of functions (defining and invoking functions)</h2>

︡f1614983-da22-4ecf-bfb0-750ec644d0ba︡{"html": "<h2 style=\"text-align: center;\">Tiny examples of functions (defining and invoking functions)</h2>"}︡
︠3e743e54-3309-42c2-8d1f-b1907d40156d︠
# Function definition
def is_even(n):
    return n % 2 == 0
︡b5903209-9d27-4d77-9c98-0725f494b77e︡︡
︠e2d3cfd8-830a-4981-a1de-773838ca6a80︠
is_even(4)
︡4255dc84-848d-4391-bb11-f25025ff9b69︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}{\\rm True}</span>"}︡
︠ac27ed11-f800-4ad7-805c-9a2a98ee2b09︠
is_even(5)
︡064996b1-5c66-4027-8ba2-961c067773ae︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}{\\rm False}</span>"}︡
︠f4bad8b6-7f72-46df-8d0b-af24f8c0efcf︠
# generate even numbers up to n
def evens(n):
    v = []
    for i in xrange(1, n + 1):
        if is_even(i):
            v.append(i)
    return v
︡da99311e-46e0-4d3b-a2b5-6cad0d64bf2b︡︡
︠9fe865ff-b0fe-400b-a2d7-d4023812d819︠
evens(10)
︡668aad13-a8a6-49e0-b0bc-2fddab57e8ce︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left[2, 4, 6, 8, 10\\right]</span>"}︡
︠94c47d32-8b02-406f-a631-b89c8d22c444i︠
%html
<p>But this is done by... (Python's "list comprehension")</p>

︡1e1712b0-efb5-4c86-810b-e6fa7ceec2b3︡{"html": "<p>But this is done by... (Python's \"list comprehension\")</p>"}︡
︠ebc877fd-8e5c-4587-b9c4-c6ba4415b51b︠
[x for x in xrange(2,11,2)]
︡278fc667-1593-4a5c-8103-3a5eec606c15︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left[2, 4, 6, 8, 10\\right]</span>"}︡
︠84d28e2b-73b2-4973-98f3-324a1903161ci︠
%html
<h2 style="text-align: center;">Cython</h2>
<h2 style="text-align: center;">---Interface to C---</h2>
<p>The example is to compute n-th Harmonic number, the sum of 1/m, m=1,...,n. (cf. Prof. M. Kida's talk on Magma at this workshop, 2008/Dec).</p>
<p>Firstly, pure Sage (Python) version:</p>

︡8379a2b8-f56e-4121-a55a-fe6ba3248e70︡{"html": "<h2 style=\"text-align: center;\">Cython</h2>\n<h2 style=\"text-align: center;\">---Interface to C---</h2>\n<p>The example is to compute n-th Harmonic number, the sum of 1/m, m=1,...,n. (cf. Prof. M. Kida's talk on Magma at this workshop, 2008/Dec).</p>\n<p>Firstly, pure Sage (Python) version:</p>"}︡
︠71098c3b-b2ca-4b9d-8f96-a51f3d7c95c5︠
def harmonic(n):
    r = 0
    for m in xrange(1, n+1):
        r += 1/m
    return r
︡c155182b-b132-48fa-b627-d6575863607c︡︡
︠a73129e8-9792-4161-88e0-2ffbcf4e8d3bi︠
%html
<p>One can measure the time to compute something by timeit().</p>

︡74ef815a-e6f4-41df-a270-12b03fc6216b︡{"html": "<p>One can measure the time to compute something by timeit().</p>"}︡
︠ec5d54f5-4a85-4099-94ff-d1e31b9f8cab︠
timeit('harmonic(5*10^4)');
︡680354be-2d82-4ae1-9d75-5fb9737f606a︡{"stdout": "5 loops, best of 3: 2.04 s per loop"}︡
︠4bd5119e-f69b-4868-beaa-cb37a235b367i︠
%html
<p>Writing Cython code, one can incorporate C/C++ code into Sage.</p>
<p>The same routine written in C with GMP.</p>

︡9ca5ced7-d7e8-4a52-8cbe-581a6e323a8a︡{"html": "<p>Writing Cython code, one can incorporate C/C++ code into Sage.</p>\n<p>The same routine written in C with GMP.</p>"}︡
︠164ae208-7a3a-4f63-9d82-3fbbb07ad542︠
%cython
r"""
Study of using cython.
sage: load study_pyrex.pyx
This is as fast as one which written in Python/Sage.
"""

cdef extern from "gmp.h":
    ctypedef void* mpz_t
    ctypedef void* mpq_t
    void mpz_init(mpz_t integer)
    void mpq_init(mpq_t rational)
    void mpq_set_ui(mpq_t r, unsigned long a, unsigned long b)
    void mpq_inv(mpq_t inverted_num, mpq_t num)
    void mpq_add(mpq_t r, mpq_t a, mpq_t b)
    char *mpq_get_str(char *str, int base, mpq_t num)

cdef extern from "stdlib.h":
    void free(void *ptr)

def harmonic(int n):
    cdef mpq_t r # register
    cdef mpq_t t # tmp var
    cdef unsigned long c
    cdef char *s

    mpq_init(r)
    mpq_init(t)

    _sig_on
    for c from 1 <= c <= n:
        mpq_set_ui(t, 1L, c) # t <- 1/c
        mpq_add(r, r, t) # r <- r+(1/c)
    s = mpq_get_str(NULL, 10, r)
    _sig_off

    from sage.rings.rational import Rational
    u = Rational(s)
    free(s)
    return u
︡069ba15d-14c6-457d-944a-0e07176f7024︡︡
︠8fcf2afa-9044-48c3-a66b-28480f926552︠
harmonic?
︡0fe32eda-b53e-4849-9783-95574ae637e5︡{"html": "<!--notruncate-->\n<div class=\"docstring\"><p><strong>File:</strong> /home/iwao/sage-4.5.3-linux-32bit-ubuntu_10.04_lts-i686-Linux/devel/sage/_home_iwao__sage_sage_notebook_sagenb_home_admin_3_code_sage31_spyx_0.pyx</p>\n<p><strong>Type:</strong> &lt;type 'builtin_function_or_method'&gt;</p>\n<p><strong>Definition:</strong> harmonic( [noargspec] )</p>\n<p><strong>Docstring:</strong></p>\n<pre></pre></div>\n"}︡
︠1280eb94-c24e-41be-99ee-da2382ce3302i︠
%html
<p>C/Cython version seems 120% faster than original Sage version.</p>

︡9126da53-6bc9-4a41-b4ad-b7bc29d1e8fc︡{"html": "<p>C/Cython version seems 120% faster than original Sage version.</p>"}︡
︠c4204484-b2af-47f2-8e6c-475958461bba︠
timeit('harmonic(5*10^4)')
︡2f3aeb01-f0cb-4e12-a252-2aa7fa10d083︡{"stdout": "5 loops, best of 3: 1.68 s per loop"}︡
︠55167124-1a7e-4ee2-b35f-f4fa8ed7048fi︠
%html
<p>The same function can be written without using loop (sum of list version) , this is a bit faster than</p>
<p>original for loop version, but slower than C/Cython version.</p>

︡9093642b-8994-4b1b-822f-8ccb3680c9a5︡{"html": "<p>The same function can be written without using loop (sum of list version) , this is a bit faster than</p>\n<p>original for loop version, but slower than C/Cython version.</p>"}︡
︠a4e52240-ade0-4e3c-a801-f7f5fb59f877︠
timeit('sum([1/x for x in xrange(1, 5*10^4+1)])')
︡29a4192e-4d94-4bc9-845d-55890a0e0f8e︡{"stdout": "5 loops, best of 3: 1.97 s per loop"}︡
︠da6b8bf9-9f4b-453b-a0d4-ef5cf84bdb62i︠
%html
<h2 style="text-align: center;">Rings, Fields and Polynomials</h2>

︡d7b893d4-8bc9-4bfb-a315-186a3e01fb46︡{"html": "<h2 style=\"text-align: center;\">Rings, Fields and Polynomials</h2>"}︡
︠6bf57fd0-f625-40de-867f-81a3f1548fbb︠
QQ # the field of rational numbers
︡c444a258-17fb-4497-a74e-80b822e30d97︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Bold{Q}</span>"}︡
︠bfc2e1da-ba8c-44a4-844a-27a2e0404dd2︠
ZZ # the ring of rational integers
︡ee8cab0f-69d9-4c9e-8177-77bca15d609b︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Bold{Z}</span>"}︡
︠c1cffd25-b228-41b1-8513-6d419888077e︠
RR # the field of real numbers
︡c71c5941-207d-4f19-a54c-cbdee1738f7d︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Bold{R}</span>"}︡
︠55341152-9ec0-4aaf-9633-bb79a0fd7949︠
CC # the field of complex numbers
︡149939c1-11ea-4dc8-8b1a-9165a807d256︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Bold{C}</span>"}︡
︠ccd87de0-101c-4720-83c7-2acddcaf5999︠
Q7 = Qp(7); Q7 # the field of p-adic numbers, here p = 7
︡4c621610-de4f-4be9-a854-b3f81451c4ee︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\QQ_{7}</span>"}︡
︠56beb743-494e-4e44-9ee3-b24de2d0e41f︠
F7 = FiniteField(7); F7 # the field of 7-elements.
︡a544e8de-1fcb-414d-9811-0d76b1ff1c8f︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Bold{F}_{7}</span>"}︡
︠8f9c7440-05de-461e-a0cb-ec1d12415938i︠
%html
<p>We can construct the ring of polynomials over Q by several way.</p>

︡b9fec1d7-9923-4c84-bc05-8145d9ddc91b︡{"html": "<p>We can construct the ring of polynomials over Q by several way.</p>"}︡
︠3d4c16a5-0905-4bdd-8b15-6306f54381b6︠
R.<x> = PolynomialRing(QQ); R # univariate polynomial ring over Q, indeterminate is x.
︡e644d580-b346-4fd0-802d-f512824f9af4︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Bold{Q}[x]</span>"}︡
︠9a072914-700d-4d1f-9aa9-b76b1ffe8b03︠
R = QQ['x']; R # the same thing as above. TMWTDI.
︡1e0cfe81-1707-4786-ac08-ac0abcba9c80︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Bold{Q}[x]</span>"}︡
︠16189bd3-bddd-4a83-9ce0-e5260799e9c9︠
R.<x> = QQ[]; R # This works!
︡433a3659-df20-4f42-8473-f40293462fe8︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Bold{Q}[x]</span>"}︡
︠574291d6-9b21-4449-b6cc-cfdeaa0fce49i︠
%html
<p>What is 'x'?</p>

︡6b3377cd-dcba-42e4-bd62-6b082c46e296︡{"html": "<p>What is 'x'?</p>"}︡
︠83d0a89d-2b23-4e2e-984f-62b5db8b0f2a︠
parent(x)
︡2b8adfc3-fa8b-45d4-9764-85a6651f7f9b︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Bold{Q}[x]</span>"}︡
︠5db68209-4fd6-41c1-a321-f6a04032373d︠
f = 2*x^2+3*x+1; f
︡b8656fa7-55b7-442e-b0ad-f7a0abbbbde5︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}2 x^{2} + 3 x + 1</span>"}︡
︠c54ac168-41aa-4277-8928-5356bc1bbd8c︠
factor(f) # polynomial factorization
︡49bc9dbc-f679-438b-ac79-4968849e4f59︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(2\\right) \\cdot (x + \\frac{1}{2}) \\cdot (x + 1)</span>"}︡
︠2423c32c-e4bd-4684-89ae-f046e9a707ce︠
S = Q7['x']; S
︡c47ffb7d-baa6-4abc-9f92-e2c727e4d62f︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\QQ_{7}[x]</span>"}︡
︠56b81583-9f91-4400-83f6-5f9a8d8365ce︠
f7 = S(2*x^2+3*x+1); f7 # same polynomial, but over Q7.
︡dcaba4e4-ffe0-48dc-adc2-24e0aaaac720︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(2 + O(7^{20})\\right) x^{2} + \\left(3 + O(7^{20})\\right) x + 1 + O(7^{20})</span>"}︡
︠9292963d-8af7-4693-a898-e77eca75a9f4︠
factor(f7) # -1/2 to be 7-adic number.
︡5f59b4f9-5247-4bc8-9da1-fbbad2c29794︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(2 + O(7^{20})\\right) \\cdot (\\left(1 + O(7^{20})\\right) x + 1 + O(7^{20})) \\cdot (\\left(1 + O(7^{20})\\right) x + 4 + 3 \\cdot 7 + 3 \\cdot 7^{2} + 3 \\cdot 7^{3} + 3 \\cdot 7^{4} + 3 \\cdot 7^{5} + 3 \\cdot 7^{6} + 3 \\cdot 7^{7} + 3 \\cdot 7^{8} + 3 \\cdot 7^{9} + 3 \\cdot 7^{10} + 3 \\cdot 7^{11} + 3 \\cdot 7^{12} + 3 \\cdot 7^{13} + 3 \\cdot 7^{14} + 3 \\cdot 7^{15} + 3 \\cdot 7^{16} + 3 \\cdot 7^{17} + 3 \\cdot 7^{18} + 3 \\cdot 7^{19} + O(7^{20}))</span>"}︡
︠1b559841-c539-45bf-85e3-0c6c3f84a526i︠
%html
<p>Automatic Coercions!</p>
<p>see <a href="http://sagemath.blogspot.com/2010/11/brief-history-and-motivation-behind.html">http://sagemath.blogspot.com/2010/11/brief-history-and-motivation-behind.html</a></p>
<p>$f(x)\in\mathbf{Q}[x]$, $f7(x)\in\mathbf{Q}_7[x]$.</p>

︡5da98cba-66c1-47eb-8898-e74b5d9432ec︡{"html": "<p>Automatic Coercions!</p>\n<p>see <a href=\"http://sagemath.blogspot.com/2010/11/brief-history-and-motivation-behind.html\">http://sagemath.blogspot.com/2010/11/brief-history-and-motivation-behind.html</a></p>\n<p>$f(x)\\in\\mathbf{Q}[x]$, $f7(x)\\in\\mathbf{Q}_7[x]$.</p>"}︡
︠3929a692-277a-4244-af4c-b203463529bd︠
f+f7
︡d9447496-4704-4f06-9b2f-abe9d9b2aeac︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(4 + O(7^{20})\\right) x^{2} + \\left(6 + O(7^{20})\\right) x + 2 + O(7^{20})</span>"}︡
︠1b284ed9-e09e-483e-b2ac-1a346dfb1877︠
fcyc = R.cyclotomic_polynomial(7); fcyc # the 7-th cyclotomic polynomial over Q
︡787a9010-b418-490d-946d-64adf63f549c︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}x^{6} + x^{5} + x^{4} + x^{3} + x^{2} + x + 1</span>"}︡
︠e7eb535c-e04f-4df0-b2c1-bf6fe236215f︠
factor(fcyc)
︡ce5d9459-e31c-4f65-8e13-6779daa636a8︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}(x^{6} + x^{5} + x^{4} + x^{3} + x^{2} + x + 1)</span>"}︡
︠ae40a858-fe4c-4349-a7f7-c462a935e4a8︠
fcyc.is_irreducible()
︡e9b8d8b7-fed3-487e-b4b5-08b49e4b0177︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}{\\rm True}</span>"}︡
︠8759228d-5d43-4f79-b9cc-3bb5255dd6e6︠
S(fcyc)
︡0b4fc287-b356-4087-8c7f-744b8ffc9dd4︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(1 + O(7^{20})\\right) x^{6} + \\left(1 + O(7^{20})\\right) x^{5} + \\left(1 + O(7^{20})\\right) x^{4} + \\left(1 + O(7^{20})\\right) x^{3} + \\left(1 + O(7^{20})\\right) x^{2} + \\left(1 + O(7^{20})\\right) x + 1 + O(7^{20})</span>"}︡
︠43e8bd44-ee79-4d65-b960-1fa010bc53c6︠
factor(S(fcyc))
︡3765d9fb-9883-4818-af63-ed755312a718︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}(\\left(1 + O(7^{20})\\right) x^{6} + \\left(1 + O(7^{20})\\right) x^{5} + \\left(1 + O(7^{20})\\right) x^{4} + \\left(1 + O(7^{20})\\right) x^{3} + \\left(1 + O(7^{20})\\right) x^{2} + \\left(1 + O(7^{20})\\right) x + 1 + O(7^{20}))</span>"}︡
︠d16a5a3a-8ab6-49e5-b94d-4252ccdfaec1︠
factor(PolynomialRing(F7,'x')(fcyc))
︡e38ec605-1f1f-4572-a70e-9f7a660ef8b5︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}(x + 6)^{6}</span>"}︡
︠ff016853-f91a-48c4-bdb6-25b270d9c833i︠
%html
<h2 style="text-align: center;">Number Theory</h2>
<p>Some standard functionality for algebraic number fields are supplied by Sage. One can invoke pari-gp.</p>
<p>Note that the computation in Sage are done <strong>rigorously</strong>, in another word, <strong>not assuming any unproven hypothesis</strong>.</p>
<p>One can specify some parameter to assume some heuristics.</p>

︡dec41e15-c900-4bd9-aa30-b414d9852def︡{"html": "<h2 style=\"text-align: center;\">Number Theory</h2>\n<p>Some standard functionality for algebraic number fields are supplied by Sage. One can invoke pari-gp.</p>\n<p>Note that the computation in Sage are done <strong>rigorously</strong>, in another word, <strong>not assuming any unproven hypothesis</strong>.</p>\n<p>One can specify some parameter to assume some heuristics.</p>"}︡
︠a61ea8da-4596-4600-bbc6-55c17b025af0︠
k=QuadraticField(-23, 'd'); k # an imaginary quadratic field
︡0178773c-3ee9-4aa9-8a70-7813d35fe1c4︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Bold{Q}[\\sqrt{-23}]/(\\sqrt{-23}^{2} + 23)</span>"}︡
︠0bda7a5d-79e5-4468-9e54-8599f5a8c984︠
k.discriminant() # its discriminant
︡daf73d5e-ab6c-460a-93b9-f6f1541f425d︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}-23</span>"}︡
︠a7b7a737-cd07-4df2-b807-0679ca8dd477︠
k.class_number() # its class number
︡9dfad1fa-74fa-477e-821c-123a01ccc160︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}3</span>"}︡
︠9c9e8109-c650-4cbc-97dc-37f6ad64303d︠
kk=QuadraticField(-974, 'd'); kk
︡fe9766b5-32aa-4e07-b0dd-b8c6077253e5︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Bold{Q}[\\sqrt{-974}]/(\\sqrt{-974}^{2} + 974)</span>"}︡
︠78b59141-8f9a-49f6-a506-3ed2646f01ea︠
kk.class_number()
︡4aca9216-9733-431d-9a52-82db8858b006︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}36</span>"}︡
︠34047af5-8eee-4b7c-8075-9d4c83111cc5︠
C=kk.class_group(); C
︡f385927e-8e67-4c6a-998b-c2593fd35e30︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}$\\mathrm{AbelianGroup}( 2, [12, 3] )$</span>"}︡
︠72e17dd5-73c8-403f-ac71-e450d760844d︠
C.elementary_divisors()
︡36f6832d-cc84-42a0-b229-c6411ed4084a︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left[3, 12\\right]</span>"}︡
︠fb8a55f5-cf2e-4627-896c-21634daf6b79︠
F=QuadraticField(199,'d'); F # a real quadratic field
︡a795d15b-7985-4eb7-9999-0fb52d36d641︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Bold{Q}[\\sqrt{199}]/(\\sqrt{199}^{2} - 199)</span>"}︡
︠e55a4a18-365f-474e-9abe-1f5662604351︠
F.discriminant() # its discriminant
︡639f12d0-9348-453a-817f-3c2c1a8e4913︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}796</span>"}︡
︠8d61ed56-5340-431a-bbf2-bb3faec1b343︠
F.class_number() # its class number
︡b2c44ce7-92f3-4edd-9c14-b59b86c6ba9d︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}1</span>"}︡
︠499358e3-36cb-49b6-bacc-3cf01485cfd7︠
F.units() # its unit group (non-fundamental?)
︡0ea207fa-adf9-40c4-b5e7-a9ac26197bc4︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left[1153080099 \\sqrt{199} - 16266196520\\right]</span>"}︡
︠782768ce-b41d-4cd8-9089-f07330eac942︠
e = F.units()[0]; e
︡e525b683-52a8-426c-b3ab-22c16b0472ea︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}1153080099 \\sqrt{199} - 16266196520</span>"}︡
︠7b49c28f-9d9d-47ec-b69a-995faeadf0be︠
-1/e # fundamental
︡085a9269-7c9d-4d00-b10f-3740e8d2f885︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}1153080099 \\sqrt{199} + 16266196520</span>"}︡
︠80cdb490-0e94-473e-8eb1-d690805f4af9i︠
%html
<p>One can invoke pari-gp inside Sage.</p>
<p>pari-gp's quadunit() returns the fundamental unit of real quadratic fields.</p>

︡bf1dd376-0ebf-4f6f-9176-21dcd0ebeebc︡{"html": "<p>One can invoke pari-gp inside Sage.</p>\n<p>pari-gp's quadunit() returns the fundamental unit of real quadratic fields.</p>"}︡
︠aa10cdec-f76c-4411-9b41-911943e408f1︠
%gp
quadunit(4*199)
︡23cc9468-6dba-4f32-a366-1f1d34da8958︡{"stdout": "16266196520 + 1153080099*w"}︡
︠7b46026f-3192-4e9d-808c-d7b8a8984a4bi︠
%html
<h3>Cyclotomic fields</h3>

︡e432b603-ba35-457f-bf07-520d752cae63︡{"html": "<h3>Cyclotomic fields</h3>"}︡
︠17a19865-6a91-475a-8737-824c8a3cbbb7︠
k=CyclotomicField(7); k
︡01831f45-5bce-4521-88c4-5152cd22e2cd︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Bold{Q}(\\zeta_{7})</span>"}︡
︠3cecc285-6a72-42fc-a846-1ee8dd59bd2b︠
print k.class_number(), k.units()
︡6642aab6-6f2f-46ea-97a0-8570132a498b︡{"stdout": "1 [zeta7^5 + 1, zeta7^5 + zeta7]"}︡
︠e5c8f8f6-6b29-4e47-b9df-a91e3f93928di︠
%html
<p>List of subfields of $\mathbf{Q}(\zeta_7)$. But the display of outputs seems buggy...(the results is correct).</p>

︡c6820f36-8dd7-41cb-aae6-1e70f53ca90d︡{"html": "<p>List of subfields of $\\mathbf{Q}(\\zeta_7)$. But the display of outputs seems buggy...(the results is correct).</p>"}︡
︠9b8a94fb-ecfb-4847-8092-c47c661a26b6︠
k.subfields()
︡2d495156-1761-4f68-a5fa-c8377b35e61a︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left[\\left(\\Bold{Q}[\\zeta_{70}]/(\\zeta_{70} + 1), \\hbox{Ring morphism:\n  From: Number Field in zeta70 with defining polynomial x + 1\n  To:   Cyclotomic Field of order 7 and degree 6\n  Defn: -1 |--> -1}, \\mbox{\\mathrm{None}}\\right), \\left(\\Bold{Q}[\\zeta_{71}]/(\\zeta_{71}^{2} + \\zeta_{71} + 2), \\hbox{Ring morphism:\n  From: Number Field in zeta71 with defining polynomial x^2 + x + 2\n  To:   Cyclotomic Field of order 7 and degree 6\n  Defn: zeta71 |--> zeta7^4 + zeta7^2 + zeta7}, \\mbox{\\mathrm{None}}\\right), \\left(\\Bold{Q}[\\zeta_{72}]/(\\zeta_{72}^{3} + \\zeta_{72}^{2} - 2 \\zeta_{72} - 1), \\hbox{Ring morphism:\n  From: Number Field in zeta72 with defining polynomial x^3 + x^2 - 2*x - 1\n  To:   Cyclotomic Field of order 7 and degree 6\n  Defn: zeta72 |--> -zeta7^5 - zeta7^4 - zeta7^3 - zeta7^2 - 1}, \\mbox{\\mathrm{None}}\\right), \\left(\\Bold{Q}[\\zeta_{73}]/(\\zeta_{73}^{6} + \\zeta_{73}^{5} + \\zeta_{73}^{4} + \\zeta_{73}^{3} + \\zeta_{73}^{2} + \\zeta_{73} + 1), \\hbox{Ring morphism:\n  From: Number Field in zeta73 with defining polynomial x^6 + x^5 + x^4 + x^3 + x^2 + x + 1\n  To:   Cyclotomic Field of order 7 and degree 6\n  Defn: zeta73 |--> zeta7}, \\hbox{Ring morphism:\n  From: Cyclotomic Field of order 7 and degree 6\n  To:   Number Field in zeta73 with defining polynomial x^6 + x^5 + x^4 + x^3 + x^2 + x + 1\n  Defn: zeta7 |--> zeta73}\\right)\\right]</span>"}︡
︠d6beac29-92ee-4689-a1be-2d51f3f1804e︠
fcyc # the 7-th cylotomic polynomial over Q
︡e155c83b-6574-487e-adc9-5b4d36e4c3fe︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}x^{6} + x^{5} + x^{4} + x^{3} + x^{2} + x + 1</span>"}︡
︠5f219d75-a4c0-423a-a6b8-6bdca32ea8d5︠
S.<x>=PolynomialRing(k,'x'); S # the univariate polynomial ring over the 7-th cyclotomic field Q(zeta7)
︡9fb76208-31e0-4d06-b480-87eb65cf06ab︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Bold{Q}(\\zeta_{7})[x]</span>"}︡
︠6a8251d9-e657-4b37-b9b8-5416143bb6ca︠
S.cyclotomic_polynomial(7).factor() # try to factor the 7-th cylotomic polynomial over Q(zeta7)
︡68a66a13-4dd8-4613-9b66-faf8d71e82f6︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}(x - \\zeta_{7}) \\cdot (x - \\zeta_{7}^{2}) \\cdot (x - \\zeta_{7}^{3}) \\cdot (x - \\zeta_{7}^{4}) \\cdot (x - \\zeta_{7}^{5}) \\cdot (x + \\zeta_{7}^{5} + \\zeta_{7}^{4} + \\zeta_{7}^{3} + \\zeta_{7}^{2} + \\zeta_{7} + 1)</span>"}︡
︠fa11d86c-0016-41fd-a401-32676798b3d5i︠
%html
<h3>Dirichlet Characters</h3>
<p>One can easily construct a group of Dirichlet characters of given conductor.</p>

︡d0f8f4bd-99fa-4e4e-935b-b174d71412c9︡{"html": "<h3>Dirichlet Characters</h3>\n<p>One can easily construct a group of Dirichlet characters of given conductor.</p>"}︡
︠c5460bdc-d042-4e3c-8e83-55ec2dc57931︠
DG23 = DirichletGroup(23); DG23
︡0d2e7a04-d121-4411-b18d-50b41cba179e︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\hbox{Group of Dirichlet characters of modulus 23 over Cyclotomic Field of order 22 and degree 10}</span>"}︡
︠c2e3ae4d-6bea-4ae5-87ed-bea9d0484d2b︠
DG23.gens()
︡1c74b072-dcd5-4d09-8aa5-37ed3d76c358︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(Dirichlet character modulo 23 of conductor 23 mapping $5 \\mapsto \\zeta_{22}$\\right)</span>"}︡
︠919967cf-39fc-4e04-9afe-226af0e6717c︠
g=DG23.gen(); g
︡910cd1f6-afed-4027-b25a-7fc0a0e04d73︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}Dirichlet character modulo 23 of conductor 23 mapping $5 \\mapsto \\zeta_{22}$</span>"}︡
︠3c0d124b-db91-4c6a-a07c-f13265c95c37︠
g.bernoulli(1)
︡2138a334-a136-45fb-b3bf-91db27b38007︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}-\\frac{6}{23} \\zeta_{22}^{9} + \\frac{14}{23} \\zeta_{22}^{8} + \\frac{6}{23} \\zeta_{22}^{7} - \\frac{2}{23} \\zeta_{22}^{6} + \\frac{12}{23} \\zeta_{22}^{5} - \\frac{10}{23} \\zeta_{22}^{4} - \\frac{8}{23} \\zeta_{22}^{3} - \\frac{14}{23} \\zeta_{22}^{2} - \\frac{18}{23} \\zeta_{22} - \\frac{16}{23}</span>"}︡
︠076d9cbb-5e9c-4603-80c2-315887d7abcbi︠
%html
<p>By the analytic class number formula for an imaginary abelian field, we can compute</p>
<p>the relative class number of $\mathbf{Q}(\zeta_23)$. ($w=2*23$, $Q=1$):</p>
<p>$$h(\mathbf{Q}(\zeta_{23}))=wQ\prod_{\chi\in X^-}-\frac{B_{1,\chi}}{2}.$$</p>
<p>Dr. T. Taniguchi (Gakushuin) will give a lecture on sophisticated way to compute</p>
<p>the relative class numbers of $p$-th cyclotomic fields on 2010/Dec/26 at Kanazawa.</p>

︡921d68df-46e7-4995-8c90-6728e2a7f14d︡{"html": "<p>By the analytic class number formula for an imaginary abelian field, we can compute</p>\n<p>the relative class number of $\\mathbf{Q}(\\zeta_23)$. ($w=2*23$, $Q=1$):</p>\n<p>$$h(\\mathbf{Q}(\\zeta_{23}))=wQ\\prod_{\\chi\\in X^-}-\\frac{B_{1,\\chi}}{2}.$$</p>\n<p>Dr. T. Taniguchi (Gakushuin) will give a lecture on sophisticated way to compute</p>\n<p>the relative class numbers of $p$-th cyclotomic fields on 2010/Dec/26 at Kanazawa.</p>"}︡
︠53a19679-6ca3-4b95-9bb7-8062c317968e︠
2*23*prod([-c.bernoulli(1)/2 for c in DG23 if c.is_odd()])
︡4c655b8b-2479-45be-a489-4bcc8a017100︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}3</span>"}︡
︠b71f7d36-022a-48f1-ad08-61bcab616a31i︠
%html
<p>For a number field, Sage provides class_number() function, but this fails sadly ;_;</p>

︡b8c0056e-a74c-4a46-9ec9-3fc873b88f8c︡{"html": "<p>For a number field, Sage provides class_number() function, but this fails sadly ;_;</p>"}︡
︠5f05f271-c991-4b94-9437-f3261bf3eab3︠
NumberField(R.cyclotomic_polynomial(23),'a').class_number(proof=False)
︡9a9157f0-c64d-4f2f-9d55-83f9108bd113︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}3</span>"}︡
︠7fa0da6b-4a88-4e96-80b0-14b258149cd6i︠
%html
<p>This is because, as said before, Sage try to compute without any unproven hypothesis.</p>
<p>If one specify 'proof=False' option, Sage (in fact, pari library) computes class numbers</p>
<p>using <strong>Heuristic bound</strong> for the norm of generators of ideal class group. The result may not</p>
<p>be correct, but almost ok.</p>

<h2 style="text-align: center;">Table of Number Fields</h2>

<p>Install extra package:</p>
<p>install_package('<span style="font-family: monospace; white-space: pre;">database_jones_numfield-v4</span><span style="font-size: small;">')</span></p>

︡57aa857a-538f-44a5-ac1c-3c65574daf60︡{"html": "<p>This is because, as said before, Sage try to compute without any unproven hypothesis.</p>\n<p>If one specify 'proof=False' option, Sage (in fact, pari library) computes class numbers</p>\n<p>using <strong>Heuristic bound</strong> for the norm of generators of ideal class group. The result may not</p>\n<p>be correct, but almost ok.</p>\n\n<h2 style=\"text-align: center;\">Table of Number Fields</h2>\n\n<p>Install extra package:</p>\n<p>install_package('<span style=\"font-family: monospace; white-space: pre;\">database_jones_numfield-v4</span><span style=\"font-size: small;\">')</span></p>"}︡
︠914c4660-9bd9-4974-9d24-6b5084538701︠
JonesDatabase??
︡8f27179f-116f-4ba1-b00d-853b9dcf09d4︡{"html": "<!--notruncate-->\n<div class=\"docstring\">\n    \n  <p><strong>File:</strong> /home/iwao/sage-4.5.3-linux-32bit-ubuntu_10.04_lts-i686-Linux/local/lib/python2.6/site-packages/sage/databases/jones.py</p>\n<p><strong>Source Code</strong> (starting at line 80):</p>\n<div class=\"highlight-python\"><div class=\"highlight\"><pre class=\"literal-block\"><span class=\"k\">class</span> <span class=\"nc\">JonesDatabase</span><span class=\"p\">:</span>\n    <span class=\"k\">def</span> <span class=\"nf\">__init__</span><span class=\"p\">(</span><span class=\"bp\">self</span><span class=\"p\">):</span>\n        <span class=\"bp\">self</span><span class=\"o\">.</span><span class=\"n\">root</span> <span class=\"o\">=</span> <span class=\"bp\">None</span>\n\n    <span class=\"k\">def</span> <span class=\"nf\">__repr__</span><span class=\"p\">(</span><span class=\"bp\">self</span><span class=\"p\">):</span>\n        <span class=\"k\">return</span> <span class=\"s\">&quot;John Jones&#39;s table of number fields with bounded ramification and degree &lt;= 6&quot;</span>\n\n    <span class=\"k\">def</span> <span class=\"nf\">_load</span><span class=\"p\">(</span><span class=\"bp\">self</span><span class=\"p\">,</span> <span class=\"n\">path</span><span class=\"p\">,</span> <span class=\"n\">filename</span><span class=\"p\">):</span>\n        <span class=\"k\">print</span> <span class=\"n\">filename</span>\n        <span class=\"n\">i</span> <span class=\"o\">=</span> <span class=\"mf\">0</span>\n        <span class=\"k\">while</span> <span class=\"n\">filename</span><span class=\"p\">[</span><span class=\"n\">i</span><span class=\"p\">]</span><span class=\"o\">.</span><span class=\"n\">isalpha</span><span class=\"p\">():</span>\n            <span class=\"n\">i</span> <span class=\"o\">+=</span> <span class=\"mf\">1</span>\n        <span class=\"n\">j</span> <span class=\"o\">=</span> <span class=\"nb\">len</span><span class=\"p\">(</span><span class=\"n\">filename</span><span class=\"p\">)</span><span class=\"o\">-</span><span class=\"mf\">1</span>\n        <span class=\"k\">while</span> <span class=\"n\">filename</span><span class=\"p\">[</span><span class=\"n\">j</span><span class=\"p\">]</span><span class=\"o\">.</span><span class=\"n\">isalpha</span><span class=\"p\">()</span> <span class=\"ow\">or</span> <span class=\"n\">filename</span><span class=\"p\">[</span><span class=\"n\">j</span><span class=\"p\">]</span> <span class=\"ow\">in</span> <span class=\"p\">[</span><span class=\"s\">&quot;.&quot;</span><span class=\"p\">,</span> <span class=\"s\">&quot;_&quot;</span><span class=\"p\">]:</span>\n            <span class=\"n\">j</span> <span class=\"o\">-=</span> <span class=\"mf\">1</span>\n        <span class=\"n\">S</span> <span class=\"o\">=</span> <span class=\"p\">[</span><span class=\"nb\">eval</span><span class=\"p\">(</span><span class=\"n\">z</span><span class=\"p\">)</span> <span class=\"k\">for</span> <span class=\"n\">z</span> <span class=\"ow\">in</span> <span class=\"n\">filename</span><span class=\"p\">[</span><span class=\"n\">i</span><span class=\"p\">:</span><span class=\"n\">j</span><span class=\"o\">+</span><span class=\"mf\">1</span><span class=\"p\">]</span><span class=\"o\">.</span><span class=\"n\">split</span><span class=\"p\">(</span><span class=\"s\">&quot;-&quot;</span><span class=\"p\">)]</span>\n        <span class=\"n\">S</span><span class=\"o\">.</span><span class=\"n\">sort</span><span class=\"p\">()</span>\n        <span class=\"n\">data</span> <span class=\"o\">=</span> <span class=\"nb\">open</span><span class=\"p\">(</span><span class=\"n\">path</span> <span class=\"o\">+</span> <span class=\"s\">&quot;/&quot;</span> <span class=\"o\">+</span> <span class=\"n\">filename</span><span class=\"p\">)</span><span class=\"o\">.</span><span class=\"n\">read</span><span class=\"p\">()</span>\n        <span class=\"n\">data</span> <span class=\"o\">=</span> <span class=\"n\">data</span><span class=\"o\">.</span><span class=\"n\">replace</span><span class=\"p\">(</span><span class=\"s\">&quot;^&quot;</span><span class=\"p\">,</span><span class=\"s\">&quot;**&quot;</span><span class=\"p\">)</span>\n        <span class=\"n\">x</span> <span class=\"o\">=</span> <span class=\"n\">PolynomialRing</span><span class=\"p\">(</span><span class=\"n\">RationalField</span><span class=\"p\">(),</span> <span class=\"s\">&#39;x&#39;</span><span class=\"p\">)</span><span class=\"o\">.</span><span class=\"n\">gen</span><span class=\"p\">()</span>\n        <span class=\"n\">v</span> <span class=\"o\">=</span> <span class=\"nb\">eval</span><span class=\"p\">(</span><span class=\"n\">data</span><span class=\"p\">)</span>\n        <span class=\"n\">s</span> <span class=\"o\">=</span> <span class=\"nb\">tuple</span><span class=\"p\">(</span><span class=\"n\">S</span><span class=\"p\">)</span>\n        <span class=\"k\">if</span> <span class=\"bp\">self</span><span class=\"o\">.</span><span class=\"n\">root</span><span class=\"o\">.</span><span class=\"n\">has_key</span><span class=\"p\">(</span><span class=\"n\">s</span><span class=\"p\">):</span>\n            <span class=\"bp\">self</span><span class=\"o\">.</span><span class=\"n\">root</span><span class=\"p\">[</span><span class=\"n\">s</span><span class=\"p\">]</span> <span class=\"o\">+=</span> <span class=\"n\">v</span>\n            <span class=\"bp\">self</span><span class=\"o\">.</span><span class=\"n\">root</span><span class=\"p\">[</span><span class=\"n\">s</span><span class=\"p\">]</span><span class=\"o\">.</span><span class=\"n\">sort</span><span class=\"p\">()</span>\n        <span class=\"k\">else</span><span class=\"p\">:</span>\n            <span class=\"bp\">self</span><span class=\"o\">.</span><span class=\"n\">root</span><span class=\"p\">[</span><span class=\"n\">s</span><span class=\"p\">]</span> <span class=\"o\">=</span> <span class=\"n\">v</span>\n\n\n    <span class=\"k\">def</span> <span class=\"nf\">_init</span><span class=\"p\">(</span><span class=\"bp\">self</span><span class=\"p\">,</span> <span class=\"n\">path</span><span class=\"p\">):</span>\n        <span class=\"sd\">&quot;&quot;&quot;</span>\n<span class=\"sd\">        Create the database from scratch from the PARI files on John Jones&#39;s</span>\n<span class=\"sd\">        web page, downloaded (e.g., via wget) to a local directory, which</span>\n<span class=\"sd\">        is specified as path above.</span>\n\n<span class=\"sd\">        INPUT:</span>\n\n\n<span class=\"sd\">        -  ``path`` - (default works on William Stein install.)</span>\n<span class=\"sd\">           path must be the path to Jones&#39;s Number_Fields directory</span>\n<span class=\"sd\">           http://hobbes.la.asu.edu/Number_Fields These files should have</span>\n<span class=\"sd\">           been downloaded using wget.</span>\n\n\n<span class=\"sd\">        EXAMPLE: This is how to create the database from scratch, assuming</span>\n<span class=\"sd\">        that the number fields are in the default directory above: From a</span>\n<span class=\"sd\">        cold start of Sage::</span>\n\n<span class=\"sd\">                sage: J = JonesDatabase()</span>\n<span class=\"sd\">                sage: J._init()   # not tested</span>\n<span class=\"sd\">                ...</span>\n<span class=\"sd\">            This takes about 5 seconds.</span>\n<span class=\"sd\">        &quot;&quot;&quot;</span>\n        <span class=\"n\">n</span> <span class=\"o\">=</span> <span class=\"mf\">0</span>\n        <span class=\"n\">x</span> <span class=\"o\">=</span> <span class=\"n\">PolynomialRing</span><span class=\"p\">(</span><span class=\"n\">RationalField</span><span class=\"p\">(),</span><span class=\"s\">&#39;x&#39;</span><span class=\"p\">)</span><span class=\"o\">.</span><span class=\"n\">gen</span><span class=\"p\">()</span>\n        <span class=\"bp\">self</span><span class=\"o\">.</span><span class=\"n\">root</span> <span class=\"o\">=</span> <span class=\"p\">{}</span>\n        <span class=\"bp\">self</span><span class=\"o\">.</span><span class=\"n\">root</span><span class=\"p\">[</span><span class=\"nb\">tuple</span><span class=\"p\">([])]</span> <span class=\"o\">=</span> <span class=\"p\">[</span><span class=\"n\">x</span><span class=\"o\">-</span><span class=\"mf\">1</span><span class=\"p\">]</span>\n        <span class=\"k\">if</span> <span class=\"ow\">not</span> <span class=\"n\">os</span><span class=\"o\">.</span><span class=\"n\">path</span><span class=\"o\">.</span><span class=\"n\">exists</span><span class=\"p\">(</span><span class=\"n\">path</span><span class=\"p\">):</span>\n            <span class=\"k\">raise</span> <span class=\"ne\">IOError</span><span class=\"p\">,</span> <span class=\"s\">&quot;Path </span><span class=\"si\">%s</span><span class=\"s\"> does not exist.&quot;</span><span class=\"o\">%</span><span class=\"n\">path</span>\n        <span class=\"k\">for</span> <span class=\"n\">X</span> <span class=\"ow\">in</span> <span class=\"n\">os</span><span class=\"o\">.</span><span class=\"n\">listdir</span><span class=\"p\">(</span><span class=\"n\">path</span><span class=\"p\">):</span>\n            <span class=\"k\">if</span> <span class=\"n\">X</span><span class=\"p\">[</span><span class=\"o\">-</span><span class=\"mf\">4</span><span class=\"p\">:]</span> <span class=\"o\">==</span> <span class=\"s\">&quot;solo&quot;</span><span class=\"p\">:</span>\n                <span class=\"n\">Z</span> <span class=\"o\">=</span> <span class=\"n\">path</span> <span class=\"o\">+</span> <span class=\"s\">&quot;/&quot;</span> <span class=\"o\">+</span> <span class=\"n\">X</span>\n                <span class=\"k\">print</span> <span class=\"n\">X</span>\n                <span class=\"k\">for</span> <span class=\"n\">Y</span> <span class=\"ow\">in</span> <span class=\"n\">os</span><span class=\"o\">.</span><span class=\"n\">listdir</span><span class=\"p\">(</span><span class=\"n\">Z</span><span class=\"p\">):</span>\n                    <span class=\"k\">if</span> <span class=\"n\">Y</span><span class=\"p\">[</span><span class=\"o\">-</span><span class=\"mf\">3</span><span class=\"p\">:]</span> <span class=\"o\">==</span> <span class=\"s\">&quot;.gp&quot;</span><span class=\"p\">:</span>\n                        <span class=\"bp\">self</span><span class=\"o\">.</span><span class=\"n\">_load</span><span class=\"p\">(</span><span class=\"n\">Z</span><span class=\"p\">,</span> <span class=\"n\">Y</span><span class=\"p\">)</span>\n        <span class=\"k\">if</span> <span class=\"ow\">not</span> <span class=\"n\">os</span><span class=\"o\">.</span><span class=\"n\">path</span><span class=\"o\">.</span><span class=\"n\">exists</span><span class=\"p\">(</span><span class=\"n\">JONESDATA</span><span class=\"p\">):</span>\n            <span class=\"n\">os</span><span class=\"o\">.</span><span class=\"n\">makedirs</span><span class=\"p\">(</span><span class=\"n\">JONESDATA</span><span class=\"p\">)</span>\n        <span class=\"n\">save</span><span class=\"p\">(</span><span class=\"bp\">self</span><span class=\"o\">.</span><span class=\"n\">root</span><span class=\"p\">,</span> <span class=\"n\">JONESDATA</span><span class=\"o\">+</span> <span class=\"s\">&quot;/jones.sobj&quot;</span><span class=\"p\">)</span>\n\n    <span class=\"k\">def</span> <span class=\"nf\">unramified_outside</span><span class=\"p\">(</span><span class=\"bp\">self</span><span class=\"p\">,</span> <span class=\"n\">S</span><span class=\"p\">,</span> <span class=\"n\">d</span><span class=\"o\">=</span><span class=\"bp\">None</span><span class=\"p\">,</span> <span class=\"n\">var</span><span class=\"o\">=</span><span class=\"s\">&#39;a&#39;</span><span class=\"p\">):</span>\n        <span class=\"sd\">&quot;&quot;&quot;</span>\n<span class=\"sd\">        Return all fields in the database of degree d unramified</span>\n<span class=\"sd\">        outside S. If d is omitted, return fields of any degree up to 6.</span>\n<span class=\"sd\">        The fields are ordered by degree and discriminant.</span>\n\n<span class=\"sd\">        INPUT:</span>\n\n\n<span class=\"sd\">        -  ``S`` - list or set of primes, or a single prime</span>\n\n<span class=\"sd\">        -  ``d`` - None (default, in which case all fields of degree &lt;= 6 are returned)</span>\n<span class=\"sd\">           or a positive integer giving the degree of the number fields returned.</span>\n\n<span class=\"sd\">        -  ``var`` - the name used for the generator of the number fields (default &#39;a&#39;).</span>\n\n<span class=\"sd\">        EXAMPLES::</span>\n\n<span class=\"sd\">            sage: J = JonesDatabase()             # optional - jones_database</span>\n<span class=\"sd\">            sage: J.unramified_outside([101,109]) # optional - jones_database</span>\n<span class=\"sd\">            [Number Field in a with defining polynomial x - 1,</span>\n<span class=\"sd\">             Number Field in a with defining polynomial x^2 - 101,</span>\n<span class=\"sd\">             Number Field in a with defining polynomial x^2 - 109,</span>\n<span class=\"sd\">             Number Field in a with defining polynomial x^3 - x^2 - 36*x + 4,</span>\n<span class=\"sd\">             Number Field in a with defining polynomial x^4 - x^3 + 13*x^2 - 19*x + 361,</span>\n<span class=\"sd\">             Number Field in a with defining polynomial x^4 - x^3 + 14*x^2 + 34*x + 393,</span>\n<span class=\"sd\">             Number Field in a with defining polynomial x^5 + 2*x^4 + 7*x^3 + 4*x^2 + 11*x - 6,</span>\n<span class=\"sd\">             Number Field in a with defining polynomial x^5 + x^4 - 6*x^3 - x^2 + 18*x + 4,</span>\n<span class=\"sd\">             Number Field in a with defining polynomial x^5 - x^4 - 40*x^3 - 93*x^2 - 21*x + 17]</span>\n<span class=\"sd\">        &quot;&quot;&quot;</span>\n        <span class=\"k\">try</span><span class=\"p\">:</span>\n            <span class=\"n\">S</span> <span class=\"o\">=</span> <span class=\"nb\">list</span><span class=\"p\">(</span><span class=\"n\">S</span><span class=\"p\">)</span>\n        <span class=\"k\">except</span> <span class=\"ne\">TypeError</span><span class=\"p\">:</span>\n            <span class=\"n\">S</span> <span class=\"o\">=</span> <span class=\"p\">[</span><span class=\"n\">S</span><span class=\"p\">]</span>\n        <span class=\"n\">Z</span> <span class=\"o\">=</span> <span class=\"p\">[]</span>\n        <span class=\"k\">for</span> <span class=\"n\">X</span> <span class=\"ow\">in</span> <span class=\"n\">powerset</span><span class=\"p\">(</span><span class=\"n\">S</span><span class=\"p\">):</span>\n            <span class=\"n\">Z</span> <span class=\"o\">+=</span> <span class=\"bp\">self</span><span class=\"o\">.</span><span class=\"n\">ramified_at</span><span class=\"p\">(</span><span class=\"n\">X</span><span class=\"p\">,</span> <span class=\"n\">d</span><span class=\"o\">=</span><span class=\"n\">d</span><span class=\"p\">,</span> <span class=\"n\">var</span><span class=\"o\">=</span><span class=\"n\">var</span><span class=\"p\">)</span>\n        <span class=\"n\">Z</span> <span class=\"o\">=</span> <span class=\"p\">[(</span><span class=\"n\">k</span><span class=\"o\">.</span><span class=\"n\">degree</span><span class=\"p\">(),</span> <span class=\"n\">k</span><span class=\"o\">.</span><span class=\"n\">discriminant</span><span class=\"p\">()</span><span class=\"o\">.</span><span class=\"n\">abs</span><span class=\"p\">(),</span> <span class=\"n\">k</span><span class=\"o\">.</span><span class=\"n\">discriminant</span><span class=\"p\">()</span> <span class=\"o\">&gt;</span> <span class=\"mf\">0</span><span class=\"p\">,</span> <span class=\"n\">k</span><span class=\"p\">)</span> <span class=\"k\">for</span> <span class=\"n\">k</span> <span class=\"ow\">in</span> <span class=\"n\">Z</span><span class=\"p\">]</span>\n        <span class=\"n\">Z</span><span class=\"o\">.</span><span class=\"n\">sort</span><span class=\"p\">()</span>\n        <span class=\"k\">return</span> <span class=\"p\">[</span><span class=\"n\">z</span><span class=\"p\">[</span><span class=\"o\">-</span><span class=\"mf\">1</span><span class=\"p\">]</span> <span class=\"k\">for</span> <span class=\"n\">z</span> <span class=\"ow\">in</span> <span class=\"n\">Z</span><span class=\"p\">]</span>\n\n    <span class=\"k\">def</span> <span class=\"nf\">__getitem__</span><span class=\"p\">(</span><span class=\"bp\">self</span><span class=\"p\">,</span> <span class=\"n\">S</span><span class=\"p\">):</span>\n        <span class=\"k\">return</span> <span class=\"bp\">self</span><span class=\"o\">.</span><span class=\"n\">get</span><span class=\"p\">(</span><span class=\"n\">S</span><span class=\"p\">)</span>\n\n    <span class=\"k\">def</span> <span class=\"nf\">get</span><span class=\"p\">(</span><span class=\"bp\">self</span><span class=\"p\">,</span> <span class=\"n\">S</span><span class=\"p\">,</span> <span class=\"n\">var</span><span class=\"o\">=</span><span class=\"s\">&#39;a&#39;</span><span class=\"p\">):</span>\n        <span class=\"sd\">&quot;&quot;&quot;</span>\n<span class=\"sd\">        Return all fields in the database ramified exactly at</span>\n<span class=\"sd\">        the primes in S.</span>\n\n<span class=\"sd\">        INPUT:</span>\n\n<span class=\"sd\">        -  ``S`` - list or set of primes, or a single prime</span>\n\n<span class=\"sd\">        -  ``var`` - the name used for the generator of the number fields (default &#39;a&#39;).</span>\n\n<span class=\"sd\">        EXAMPLES::</span>\n\n<span class=\"sd\">            sage: J = JonesDatabase()              # optional - jones_database</span>\n<span class=\"sd\">            sage: J.get(163, var=&#39;z&#39;)              # optional - jones_database</span>\n<span class=\"sd\">            [Number Field in z with defining polynomial x^2 + 163,</span>\n<span class=\"sd\">             Number Field in z with defining polynomial x^3 - x^2 - 54*x + 169,</span>\n<span class=\"sd\">             Number Field in z with defining polynomial x^4 - x^3 - 7*x^2 + 2*x + 9]</span>\n<span class=\"sd\">            sage: J.get([3, 4])                    # optional - jones_database</span>\n<span class=\"sd\">            Traceback (most recent call last):</span>\n<span class=\"sd\">            ...</span>\n<span class=\"sd\">            ValueError: S must be a list of primes</span>\n<span class=\"sd\">        &quot;&quot;&quot;</span>\n        <span class=\"k\">if</span> <span class=\"bp\">self</span><span class=\"o\">.</span><span class=\"n\">root</span> <span class=\"ow\">is</span> <span class=\"bp\">None</span><span class=\"p\">:</span>\n            <span class=\"k\">if</span> <span class=\"n\">os</span><span class=\"o\">.</span><span class=\"n\">path</span><span class=\"o\">.</span><span class=\"n\">exists</span><span class=\"p\">(</span><span class=\"n\">JONESDATA</span><span class=\"o\">+</span> <span class=\"s\">&quot;/jones.sobj&quot;</span><span class=\"p\">):</span>\n                <span class=\"bp\">self</span><span class=\"o\">.</span><span class=\"n\">root</span> <span class=\"o\">=</span> <span class=\"n\">load</span><span class=\"p\">(</span><span class=\"n\">JONESDATA</span><span class=\"o\">+</span> <span class=\"s\">&quot;/jones.sobj&quot;</span><span class=\"p\">)</span>\n            <span class=\"k\">else</span><span class=\"p\">:</span>\n                <span class=\"k\">raise</span> <span class=\"ne\">RuntimeError</span><span class=\"p\">,</span> <span class=\"s\">&quot;You must install the Jones database optional package.&quot;</span>\n        <span class=\"k\">try</span><span class=\"p\">:</span>\n            <span class=\"n\">S</span> <span class=\"o\">=</span> <span class=\"nb\">list</span><span class=\"p\">(</span><span class=\"n\">S</span><span class=\"p\">)</span>\n        <span class=\"k\">except</span> <span class=\"ne\">TypeError</span><span class=\"p\">:</span>\n            <span class=\"n\">S</span> <span class=\"o\">=</span> <span class=\"p\">[</span><span class=\"n\">S</span><span class=\"p\">]</span>\n        <span class=\"k\">if</span> <span class=\"ow\">not</span> <span class=\"n\">all</span><span class=\"p\">([</span><span class=\"n\">p</span><span class=\"o\">.</span><span class=\"n\">is_prime</span><span class=\"p\">()</span> <span class=\"k\">for</span> <span class=\"n\">p</span> <span class=\"ow\">in</span> <span class=\"n\">S</span><span class=\"p\">]):</span>\n            <span class=\"k\">raise</span> <span class=\"ne\">ValueError</span><span class=\"p\">,</span> <span class=\"s\">&quot;S must be a list of primes&quot;</span>\n        <span class=\"n\">S</span><span class=\"o\">.</span><span class=\"n\">sort</span><span class=\"p\">()</span>\n        <span class=\"n\">s</span> <span class=\"o\">=</span> <span class=\"nb\">tuple</span><span class=\"p\">(</span><span class=\"n\">S</span><span class=\"p\">)</span>\n        <span class=\"k\">if</span> <span class=\"ow\">not</span> <span class=\"bp\">self</span><span class=\"o\">.</span><span class=\"n\">root</span><span class=\"o\">.</span><span class=\"n\">has_key</span><span class=\"p\">(</span><span class=\"n\">s</span><span class=\"p\">):</span>\n            <span class=\"k\">return</span> <span class=\"p\">[]</span>\n        <span class=\"k\">return</span> <span class=\"p\">[</span><span class=\"n\">NumberField</span><span class=\"p\">(</span><span class=\"n\">f</span><span class=\"p\">,</span> <span class=\"n\">var</span><span class=\"p\">,</span> <span class=\"n\">check</span><span class=\"o\">=</span><span class=\"bp\">False</span><span class=\"p\">)</span> <span class=\"k\">for</span> <span class=\"n\">f</span> <span class=\"ow\">in</span> <span class=\"bp\">self</span><span class=\"o\">.</span><span class=\"n\">root</span><span class=\"p\">[</span><span class=\"n\">s</span><span class=\"p\">]]</span>\n\n    <span class=\"k\">def</span> <span class=\"nf\">ramified_at</span><span class=\"p\">(</span><span class=\"bp\">self</span><span class=\"p\">,</span> <span class=\"n\">S</span><span class=\"p\">,</span> <span class=\"n\">d</span><span class=\"o\">=</span><span class=\"bp\">None</span><span class=\"p\">,</span> <span class=\"n\">var</span><span class=\"o\">=</span><span class=\"s\">&#39;a&#39;</span><span class=\"p\">):</span>\n        <span class=\"sd\">&quot;&quot;&quot;</span>\n<span class=\"sd\">        Return all fields in the database of degree d ramified exactly at</span>\n<span class=\"sd\">        the primes in S.  The fields are ordered by degree and discriminant.</span>\n\n<span class=\"sd\">        INPUT:</span>\n\n<span class=\"sd\">        -  ``S`` - list or set of primes</span>\n\n<span class=\"sd\">        -  ``d`` - None (default, in which case all fields of degree &lt;= 6 are returned)</span>\n<span class=\"sd\">           or a positive integer giving the degree of the number fields returned.</span>\n\n<span class=\"sd\">        -  ``var`` - the name used for the generator of the number fields (default &#39;a&#39;).</span>\n\n<span class=\"sd\">        EXAMPLES::</span>\n\n<span class=\"sd\">            sage: J = JonesDatabase()              # optional - jones_database</span>\n<span class=\"sd\">            sage: J.ramified_at([101,109])         # optional - jones_database</span>\n<span class=\"sd\">            []</span>\n<span class=\"sd\">            sage: J.ramified_at([109])             # optional - jones_database</span>\n<span class=\"sd\">            [Number Field in a with defining polynomial x^2 - 109,</span>\n<span class=\"sd\">             Number Field in a with defining polynomial x^3 - x^2 - 36*x + 4,</span>\n<span class=\"sd\">             Number Field in a with defining polynomial x^4 - x^3 + 14*x^2 + 34*x + 393]</span>\n<span class=\"sd\">            sage: J.ramified_at(101)               # optional - jones_database</span>\n<span class=\"sd\">            [Number Field in a with defining polynomial x^2 - 101,</span>\n<span class=\"sd\">             Number Field in a with defining polynomial x^4 - x^3 + 13*x^2 - 19*x + 361,</span>\n<span class=\"sd\">             Number Field in a with defining polynomial x^5 + 2*x^4 + 7*x^3 + 4*x^2 + 11*x - 6,</span>\n<span class=\"sd\">             Number Field in a with defining polynomial x^5 + x^4 - 6*x^3 - x^2 + 18*x + 4,</span>\n<span class=\"sd\">             Number Field in a with defining polynomial x^5 - x^4 - 40*x^3 - 93*x^2 - 21*x + 17]</span>\n<span class=\"sd\">            sage: J.ramified_at((2, 5, 29), 3, &#39;c&#39;) # optional - jones_database</span>\n<span class=\"sd\">            [Number Field in c with defining polynomial x^3 - x^2 - 8*x - 28,</span>\n<span class=\"sd\">             Number Field in c with defining polynomial x^3 - x^2 + 10*x + 102,</span>\n<span class=\"sd\">             Number Field in c with defining polynomial x^3 - x^2 + 97*x - 333,</span>\n<span class=\"sd\">             Number Field in c with defining polynomial x^3 - x^2 - 48*x - 188]</span>\n<span class=\"sd\">        &quot;&quot;&quot;</span>\n        <span class=\"n\">Z</span> <span class=\"o\">=</span> <span class=\"bp\">self</span><span class=\"o\">.</span><span class=\"n\">get</span><span class=\"p\">(</span><span class=\"n\">S</span><span class=\"p\">,</span> <span class=\"n\">var</span><span class=\"o\">=</span><span class=\"n\">var</span><span class=\"p\">)</span>\n        <span class=\"k\">if</span> <span class=\"n\">d</span> <span class=\"o\">==</span> <span class=\"bp\">None</span><span class=\"p\">:</span>\n            <span class=\"n\">Z</span> <span class=\"o\">=</span> <span class=\"p\">[(</span><span class=\"n\">k</span><span class=\"o\">.</span><span class=\"n\">degree</span><span class=\"p\">(),</span> <span class=\"n\">k</span><span class=\"o\">.</span><span class=\"n\">discriminant</span><span class=\"p\">()</span><span class=\"o\">.</span><span class=\"n\">abs</span><span class=\"p\">(),</span> <span class=\"n\">k</span><span class=\"o\">.</span><span class=\"n\">discriminant</span><span class=\"p\">()</span> <span class=\"o\">&gt;</span> <span class=\"mf\">0</span><span class=\"p\">,</span> <span class=\"n\">k</span><span class=\"p\">)</span> <span class=\"k\">for</span> <span class=\"n\">k</span> <span class=\"ow\">in</span> <span class=\"n\">Z</span><span class=\"p\">]</span>\n        <span class=\"k\">else</span><span class=\"p\">:</span>\n            <span class=\"n\">Z</span> <span class=\"o\">=</span> <span class=\"p\">[(</span><span class=\"n\">k</span><span class=\"o\">.</span><span class=\"n\">discriminant</span><span class=\"p\">()</span><span class=\"o\">.</span><span class=\"n\">abs</span><span class=\"p\">(),</span> <span class=\"n\">k</span><span class=\"o\">.</span><span class=\"n\">discriminant</span><span class=\"p\">()</span> <span class=\"o\">&gt;</span> <span class=\"mf\">0</span><span class=\"p\">,</span> <span class=\"n\">k</span><span class=\"p\">)</span> <span class=\"k\">for</span> <span class=\"n\">k</span> <span class=\"ow\">in</span> <span class=\"n\">Z</span> <span class=\"k\">if</span> <span class=\"n\">k</span><span class=\"o\">.</span><span class=\"n\">degree</span><span class=\"p\">()</span> <span class=\"o\">==</span> <span class=\"n\">d</span><span class=\"p\">]</span>\n        <span class=\"n\">Z</span><span class=\"o\">.</span><span class=\"n\">sort</span><span class=\"p\">()</span>\n        <span class=\"k\">return</span> <span class=\"p\">[</span><span class=\"n\">z</span><span class=\"p\">[</span><span class=\"o\">-</span><span class=\"mf\">1</span><span class=\"p\">]</span> <span class=\"k\">for</span> <span class=\"n\">z</span> <span class=\"ow\">in</span> <span class=\"n\">Z</span><span class=\"p\">]</span>\n</pre></div>\n</div>\n\n\n</div>\n"}︡
︠45ca1aa7-9ffc-48be-a7c6-4ac114e6b4f0︠
J=JonesDatabase(); J
︡f785a6b9-67a9-4360-bcad-5c4da4f65a24︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\hbox{John Jones's table of number fields with bounded ramification and degree  < = 6}</span>"}︡
︠405490a5-3f10-4f5a-b880-3e0d031bb3b4︠
for f in J.unramified_outside(2):
    print f
︡ad32efcc-7502-447c-b377-896bb35be5f5︡{"stdout": "Number Field in a with defining polynomial x - 1\nNumber Field in a with defining polynomial x^2 + 1\nNumber Field in a with defining polynomial x^2 + 2\nNumber Field in a with defining polynomial x^2 - 2\nNumber Field in a with defining polynomial x^4 + 1\nNumber Field in a with defining polynomial x^4 - 2*x^2 + 2\nNumber Field in a with defining polynomial x^4 - 2*x^2 - 1\nNumber Field in a with defining polynomial x^4 - 2\nNumber Field in a with defining polynomial x^4 - 4*x^2 + 2\nNumber Field in a with defining polynomial x^4 + 2\nNumber Field in a with defining polynomial x^4 + 4*x^2 + 2"}︡
︠80cbc7a9-70c2-47fd-b60e-8e279cd7f595i︠
%html
<h2 style="text-align: center;">Finite Fields</h2>

︡970aef26-2bb8-4587-987e-f57f78405fe7︡{"html": "<h2 style=\"text-align: center;\">Finite Fields</h2>"}︡
︠9865915e-afc2-4329-946a-8ca120d39755︠
p = next_prime(10^5); p # the prime next to 10^5
︡de7a207d-7d4d-4816-b1fc-a3aac047cb6e︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}100003</span>"}︡
︠d10b631a-be96-4416-b059-aab065b2fc49︠
F = FiniteField(p); F # the finite field of p elements
︡5c776dea-e98e-4744-9fcf-04ca010343ac︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Bold{F}_{100003}</span>"}︡
︠eedb506d-0616-475b-8274-2af8f1a106a9︠
b=F.multiplicative_generator(); b # a primitive root mod p
︡5d6d9f8c-90c2-4a98-b48c-acd8f76baaca︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}2</span>"}︡
︠9570a5a0-2aa5-4722-8d20-9e8af46662d1︠
F(3).log(b) # the discrete log of 3 w. r. t. b
︡c5ea765b-1142-4831-bd52-320f18f8d7dc︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}86449</span>"}︡
︠e37a3412-594c-4e09-ae5f-a04d9be6bf87︠
b^86449
︡e8c89f6a-1f93-4fdf-a383-3589a7aac0f1︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}3</span>"}︡
︠c66fc6d2-29ed-4773-ac86-f78c1deb6001i︠
%html
<p>One can get a finite field with p-power elements.</p>

︡41593f6e-84dc-4678-901f-2847491c9a7c︡{"html": "<p>One can get a finite field with p-power elements.</p>"}︡
︠bee70d80-b510-49f8-92da-c3111981ec7c︠
FF = FiniteField(p^2, 'a'); FF
︡464f9202-1e77-4d9d-8cb4-81cdfc33b36c︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Bold{F}_{100003^{2}}</span>"}︡
︠6d774dfe-e3ca-48f8-baf7-0df721228cf9i︠
%html
<h2 style="text-align: center;">Elliptic Curves</h2>

︡ed8d39ad-fc29-4691-bb19-c32447aac4be︡{"html": "<h2 style=\"text-align: center;\">Elliptic Curves</h2>"}︡
︠68f2d0e9-621c-4c7c-a704-44768742e104︠
E = EllipticCurve([-82, 0]); E # if only 2 arg's a, b are given, then it means y^2 = x^3 + ax + b.
︡a1fa0bb4-c355-4388-afdc-91c115b0db0d︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}y^2 = x^3 - 82x </span>"}︡
︠64f70d10-9189-4897-8b30-353ccbf09322︠
E.discriminant().factor() # good red. outside 2, 41.
︡539c4d31-1f4a-4444-afdd-03e8400aafee︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}2^{9} \\cdot 41^{3}</span>"}︡
︠405341a2-65ce-4a89-8550-4f2dd071f00b︠
E.gens() # generator of rational points.
︡0303f2b0-f8d7-4307-95aa-9970a66db1e3︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left[\\left(-9 : 3 : 1\\right), \\left(-8 : 12 : 1\\right), \\left(-1 : 9 : 1\\right)\\right]</span>"}︡
︠57bb0ff5-f1a5-4b50-8409-e00241f872f5︠
E.rank() # the Mordell-Weil rank is 3.
︡26bf2f3e-f7a0-4293-990c-137c5916d94f︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}3</span>"}︡
︠3a6e57b8-38ae-416f-8b01-ee39ae328484︠
E.has_cm() # this is CM elliptic curve.
︡82107bab-c087-4233-928a-458dfba13546︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}{\\rm True}</span>"}︡
︠2516821a-6a78-4dbb-a15c-4f758892172a︠
L=E.lseries(); L
︡2fd58399-56ec-47cf-813b-cdc31737e2c4︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\hbox{Complex L-series of the Elliptic Curve defined by y^2 = x^3 - 82*x over Rational Field}</span>"}︡
︠fea028bc-d8c5-4878-8126-71325f4ceff6︠
L.taylor_series(a=1) # Taylor expansion at 1. Note that first 2 coeff's are so small, that this series seems to have order 3 at 1.
︡e69a7fe6-fa46-4ffe-8bfc-331f63298c08︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(1.19494180421891 \\times 10^{-22}\\right)z + \\left(-4.86468940988621 \\times 10^{-22}\\right)z^{2} + 17.7891345770978z^{3} - 72.4207775497614z^{4} + 161.461585497778z^{5} + O(z^{6})</span>"}︡
︠bfbe14b1-ecb2-4e88-beea-b9652e16e362︠
E.analytic_rank() # Sage says so.
︡6077b305-46ba-41b2-a16d-f8cb1f34e81a︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}3</span>"}︡
︠b81df908-23dc-49fc-99c4-d90336bd0157︠
E.analytic_rank?
︡07a861aa-07f3-499a-bcfb-d71d43c219dc︡{"html": "<!--notruncate-->\n<div class=\"docstring\">\n    \n  <p><strong>File:</strong> /home/iwao/sage-4.5.3-linux-32bit-ubuntu_10.04_lts-i686-Linux/local/lib/python2.6/site-packages/sage/schemes/elliptic_curves/ell_rational_field.py</p>\n<p><strong>Type:</strong> &lt;type &#8216;instancemethod&#8217;&gt;</p>\n<p><strong>Definition:</strong> E.analytic_rank(algorithm=&#8217;cremona&#8217;)</p>\n<p><strong>Docstring:</strong></p>\n<blockquote>\n<p>Return an integer that is <em>probably</em> the analytic rank of this\nelliptic curve.</p>\n<p>INPUT:</p>\n<ul class=\"simple\">\n<li>algorithm -<ul>\n<li>&#8216;cremona&#8217; (default) - Use the Buhler-Gross algorithm as\nimplemented in GP by Tom Womack and John Cremona, who note\nthat their implementation is practical for any rank and\nconductor <span class=\"math\">\\leq 10^{10}</span> in 10 minutes.</li>\n<li>&#8216;sympow&#8217; -use Watkins&#8217;s program sympow</li>\n<li>&#8216;rubinstein&#8217; - use Rubinstein&#8217;s L-function C++ program lcalc.</li>\n<li>&#8216;magma&#8217; - use MAGMA</li>\n<li>&#8216;all&#8217; - compute with all other free algorithms, check that\nthe answers agree, and return the common answer.</li>\n</ul>\n</li>\n</ul>\n<div class=\"admonition note\">\n<p class=\"first admonition-title\">Note</p>\n<p class=\"last\">If the curve is loaded from the large Cremona database,\nthen the modular degree is taken from the database.</p>\n</div>\n<p>Of the three above, probably Rubinstein&#8217;s is the most\nefficient (in some limited testing I&#8217;ve done).</p>\n<div class=\"admonition note\">\n<p class=\"first admonition-title\">Note</p>\n<p class=\"last\">It is an open problem to <em>prove</em> that <em>any</em> particular\nelliptic curve has analytic rank <span class=\"math\">\\geq 4</span>.</p>\n</div>\n<p>EXAMPLES:</p>\n<div class=\"highlight-python\"><div class=\"highlight\"><pre class=\"literal-block\"><span class=\"gp\">sage: </span><span class=\"n\">E</span> <span class=\"o\">=</span> <span class=\"n\">EllipticCurve</span><span class=\"p\">(</span><span class=\"s\">&#39;389a&#39;</span><span class=\"p\">)</span>\n<span class=\"gp\">sage: </span><span class=\"n\">E</span><span class=\"o\">.</span><span class=\"n\">analytic_rank</span><span class=\"p\">(</span><span class=\"n\">algorithm</span><span class=\"o\">=</span><span class=\"s\">&#39;cremona&#39;</span><span class=\"p\">)</span>\n<span class=\"go\">2</span>\n<span class=\"gp\">sage: </span><span class=\"n\">E</span><span class=\"o\">.</span><span class=\"n\">analytic_rank</span><span class=\"p\">(</span><span class=\"n\">algorithm</span><span class=\"o\">=</span><span class=\"s\">&#39;rubinstein&#39;</span><span class=\"p\">)</span>\n<span class=\"go\">2</span>\n<span class=\"gp\">sage: </span><span class=\"n\">E</span><span class=\"o\">.</span><span class=\"n\">analytic_rank</span><span class=\"p\">(</span><span class=\"n\">algorithm</span><span class=\"o\">=</span><span class=\"s\">&#39;sympow&#39;</span><span class=\"p\">)</span>\n<span class=\"go\">2</span>\n<span class=\"gp\">sage: </span><span class=\"n\">E</span><span class=\"o\">.</span><span class=\"n\">analytic_rank</span><span class=\"p\">(</span><span class=\"n\">algorithm</span><span class=\"o\">=</span><span class=\"s\">&#39;magma&#39;</span><span class=\"p\">)</span>    <span class=\"c\"># optional - magma</span>\n<span class=\"go\">2</span>\n<span class=\"gp\">sage: </span><span class=\"n\">E</span><span class=\"o\">.</span><span class=\"n\">analytic_rank</span><span class=\"p\">(</span><span class=\"n\">algorithm</span><span class=\"o\">=</span><span class=\"s\">&#39;all&#39;</span><span class=\"p\">)</span>\n<span class=\"go\">2</span>\n</pre></div>\n</div>\n<p>TESTS:</p>\n<p>When the input is horrendous, some of the algorithms just bomb out with a RuntimeError:</p>\n<div class=\"highlight-python\"><div class=\"highlight\"><pre class=\"literal-block\"><span class=\"gp\">sage: </span><span class=\"n\">EllipticCurve</span><span class=\"p\">([</span><span class=\"mf\">1234567</span><span class=\"p\">,</span><span class=\"mf\">89101112</span><span class=\"p\">])</span><span class=\"o\">.</span><span class=\"n\">analytic_rank</span><span class=\"p\">(</span><span class=\"n\">algorithm</span><span class=\"o\">=</span><span class=\"s\">&#39;rubinstein&#39;</span><span class=\"p\">)</span>\n<span class=\"gp\">...</span>\n<span class=\"go\">RuntimeError: unable to compute analytic rank using rubinstein algorithm (&#39;unable to convert x (= 6.19283e+19 and is too large) to an integer&#39;)</span>\n<span class=\"gp\">sage: </span><span class=\"n\">EllipticCurve</span><span class=\"p\">([</span><span class=\"mf\">1234567</span><span class=\"p\">,</span><span class=\"mf\">89101112</span><span class=\"p\">])</span><span class=\"o\">.</span><span class=\"n\">analytic_rank</span><span class=\"p\">(</span><span class=\"n\">algorithm</span><span class=\"o\">=</span><span class=\"s\">&#39;sympow&#39;</span><span class=\"p\">)</span>\n<span class=\"gp\">...</span>\n<span class=\"go\">RuntimeError: failed to compute analytic rank</span>\n</pre></div>\n</div>\n</blockquote>\n\n\n</div>\n"}︡
︠75f502dd-e810-457e-970a-3493b6f25610i︠
%html
<p>One can give an elliptic curves by its label.</p>

︡88c3ecb2-9d8c-4069-b6b9-ce171653761e︡{"html": "<p>One can give an elliptic curves by its label.</p>"}︡
︠112a23dc-6caf-4fe1-8ffd-219bc752b16d︠
E=EllipticCurve('15a2'); E
︡e2675cd8-e72e-450a-a516-1e297af62ff5︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}y^2 + xy + y = x^3 + x^2 - 135x - 660 </span>"}︡
︠51069648-8ac3-4819-9862-8d7a5373e550︠
E.has_cm()
︡2b00836c-d96a-47cb-9697-37445015697d︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}{\\rm False}</span>"}︡
︠df5f9c6a-57f4-46d1-84ac-8d91bf3a67d3︠
E.two_descent()
︡c1ee3eb4-6e36-4c8e-9cd3-a071aaa4f15a︡{"stdout": "3 points of order 2:\n[-58:25:8], [-7:3:1], [13:-7:1]\n\n****************************\n* Using 2-isogeny number 1 *\n****************************\n\nUsing 2-isogenous curve [0,164,0,6400,0] (minimal model [1,1,1,-10,-10])\n-------------------------------------------------------\nFirst step, determining 1st descent Selmer groups\n-------------------------------------------------------\nAfter first local descent, rank bound = 0\nrk(S^{phi}(E'))=\t0\nrk(S^{phi'}(E))=\t2\n\n-------------------------------------------------------\nSecond step, determining 2nd descent Selmer groups\n-------------------------------------------------------\n...skipping since we already know rank=0\nAfter second local descent, rank bound = 0\nrk(phi'(S^{2}(E)))=\t0\nrk(phi(S^{2}(E')))=\t2\nrk(S^{2}(E))=\t2\nrk(S^{2}(E'))=\t2\n\nThird step, determining E(Q)/phi(E'(Q)) and E'(Q)/phi'(E(Q))\n-------------------------------------------------------\n1. E(Q)/phi(E'(Q))\n-------------------------------------------------------\n(c,d)  =(-82,81)\n(c',d')=(164,6400)\nThis component of the rank is 0\n-------------------------------------------------------\n2. E'(Q)/phi'(E(Q))\n-------------------------------------------------------\nThis component of the rank is 0\n\n-------------------------------------------------------\nSummary of results:\n-------------------------------------------------------\n\trank(E) = 0\n\t#E(Q)/2E(Q) = 4\n\nInformation on III(E/Q):\n\t#III(E/Q)[phi']    = 1\n\t#III(E/Q)[2]       = 1\n\nInformation on III(E'/Q):\n\t#phi'(III(E/Q)[2]) = 1\n\t#III(E'/Q)[phi]    = 1\n\t#III(E'/Q)[2]      = 1\n\nSearching for points (bound = 8)...done:\n  found points of rank 0\n  and regulator 1\nProcessing points found during 2-descent...done:\n  now regulator = 1\nSaturating (bound = -1)...done:\n  points were already saturated."}︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}{\\rm True}</span>"}︡
︠bbc52d14-fc75-45aa-8c97-3d50999b2b7d︠
E.gens()
︡6333d39f-064e-479f-a2fc-50e48fbc741d︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left[\\right]</span>"}︡
︠2a6289df-45ed-4423-9497-2a39a9158f91︠
E.torsion_subgroup()
︡09008e83-2990-41a5-a2f8-0ea1654fa362︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\hbox{Torsion Subgroup isomorphic to Z/2 + Z/2 associated to the Elliptic Curve defined by y^2 + x*y + y = x^3 + x^2 - 135*x - 660 over Rational Field}</span>"}︡
︠3282ea5b-22e6-4366-b7b4-4c368037f50ai︠
%html
<h3>Invoke mwrank from Sage.</h3>
<p>Prof. H. Nakamura (Okayama U.) asked me how to compute the rational points of</p>
<p>the elliptic curve $y^2 = x^3 - 2012^2 x$ by mwrank. If it has non-trivial rational point, then $2012$ is a congruent number.</p>
<p>The answer is...</p>

︡6577e5b6-e128-4a24-905c-eb51ba821bb1︡{"html": "<h3>Invoke mwrank from Sage.</h3>\n<p>Prof. H. Nakamura (Okayama U.) asked me how to compute the rational points of</p>\n<p>the elliptic curve $y^2 = x^3 - 2012^2 x$ by mwrank. If it has non-trivial rational point, then $2012$ is a congruent number.</p>\n<p>The answer is...</p>"}︡
︠dbe2ca57-63cf-417b-aa88-fe1bd299f058︠
E2012=EllipticCurve([-2012^2,0]); E2012
︡5955bea2-4012-4698-8d74-4a657569a8bc︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}y^2 = x^3 - 4048144x </span>"}︡
︠162a8950-f052-46f9-9de2-0b49241fce5b︠
E2012.a_invariants()
︡4cab539e-225a-4340-9fba-70d8a1166a46︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(0, 0, 0, -4048144, 0\\right)</span>"}︡
︠fe93b66b-882d-4432-ab99-c14ddc03f9c3︠
E2012.discriminant()
︡d0a13ef1-20dd-482a-8222-4036f75f8f12︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}4245685614537534078976</span>"}︡
︠8187d35e-9ff3-4458-a589-9e8018f707cd︠
factor(_)
︡4de7df3f-8186-4602-889e-8d45490f794c︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}2^{18} \\cdot 503^{6}</span>"}︡
︠1222c38f-57fd-42ac-85bb-f924e01e2b1e︠
Emw=E2012.mwrank(options='-v 2 -b 15'); Emw
︡a4c2b412-b8c6-4b2c-bfdd-7f05bf5dc18e︡{"stdout": "WARNING: Output truncated!"}︡{"html": "<a target='_new' href='/home/iwaokimura/5/cells/182/full_output.txt' class='file_link'>full_output.txt</a>"}︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\hbox{Curve [0,0,0,-4048144,0] :\tWorking with minimal curve [0,0,0,-253009,0] via [u,r,s,t] = [2,0,0,0]\n\n3 points of order 2:\n[-503:0:1], [0:0:1], [503:0:1]\n\n****************************\n* Using 2-isogeny number 1 *\n****************************\n\n(c,d)  =(-1509,506018)\n(c',d')=(3018,253009)\nUsing 2-isogenous curve [0,3018,0,253009,0] (minimal model [0,0,0,-2783099,1781689378])\n-------------------------------------------------------\nFirst step, determining 1st descent Selmer groups\n-------------------------------------------------------\nFinding els gens for E (c= -1509, d= 506018)\nSupport (length 3): [ -1 2 503 ]\nAdding (torsion) els generator #1: d1 = 2\nAdding (torsion) els generator #2: d1 = 503\nAfter els sieving, nelsgens = 2\n2-rank of S^{phi}(E') = 2\n(els)gens: [ 2 503 ]\n\nFinding els gens for E' (c'= 3018, d'= 253009)\nSupport (length 2): [ -1 503 ]\nAdding els generator #1: d1 = -503\nAfter els sieving, nelsgens = 1\n2-rank of S^{phi'}(E) = 1\n(els)gens: [ -503 ]\nAfter first local descent, rank bound = 1\nrk(S^{phi}(E'))=\t2\nrk(S^{phi'}(E))=\t1\n\n-------------------------------------------------------\nSecond step, determining 2nd descent Selmer groups\n-------------------------------------------------------\nFinding els2 gens for E (c= -1509, d= 506018) which lift to S^2(E)\nAdding (torsion) els2 generator #1: d1 = 2\nAdding (torsion) els2 generator #2: d1 = 503\nAfter els2 sieving, nels2gens = 2\n2-rank of phi'(S^2(E)) = 2\n(els2)gens: [ 2 503 ]\n\nFinding els2 gens for E' (c'= 3018, d'= 253009) which lift to S^2(E')\nAdding els2 generator #1: d1 = -503\nAfter els2 sieving, nels2gens = 1\n2-rank of phi(S^2(E')) = 1\n(els2)gens: [ -503 ]\nAfter second local descent, rank bound = 1\nrk(phi'(S^{2}(E)))=\t2\nrk(phi(S^{2}(E')))=\t1\nrk(S^{2}(E))=\t3\nrk(S^{2}(E'))=\t2\n\n****************************\n* Using 2-isogeny number 2 *\n****************************\n\n(c,d)  =(0,-253009)\n\n...\n\nAdding gls generator #1: d1 = 503\nAfter second global descent, this component of the rank = 1\n\nAfter gls sieving, nglsgens = 1\nshortfall in rank from first  descent = 1\nshortfall in rank from second descent = 0\n(gls)gens: [ 503 ]\n\n-------------------------------------------------------\nSummary of results:\n-------------------------------------------------------\n\trank(E) = 1\n\t#E(Q)/2E(Q) = 8\n\nInformation on III(E/Q):\n\t#III(E/Q)[phi']    = 1\n\t#III(E/Q)[2]       = 1\n\nInformation on III(E'/Q):\n\t#phi'(III(E/Q)[2]) = 1\n\t#III(E'/Q)[phi]    = 1\n\t#III(E'/Q)[2]      = 1\n\n-------------------------------------------------------\n\nList of points on E = [0,0,0,-253009,0]:\n\nI.  Points on E mod phi(E')\n--none (modulo torsion).\n\n\nII. Points on phi(E') mod 2E\nPoint [994307871645569627047428600416268913587328092332888130249253692413707056:4967608849400271416394655945252424440618658426542146432595803800874670020:1928317088832685492020566294646267423214258259206809092654393913813973], height = 106.721376885791\n-------------------------------------------------------\nComputing full set of 2 coset representatives for\n2E(Q) in E(Q) (modulo torsion), and sorting into height order....done.\n\n\nUsed descent via 2-isogeny with isogenous curve E' = [0,0,0,-2783099,-1781689378]\nRank = 1\nRank of S^2(E)  = 3\nRank of S^2(E') = 2\nRank of S^phi(E') = 2\nRank of S^phi'(E) = 1\n\nSearching for points (bound = 8)...done:\n  found points of rank 0\n  and regulator 1\nProcessing points found during 2-descent...done:\n2-descent increases rank to 1,   now regulator = 106.721376885791\nSaturating (bound = 100)...done:\n  points were already saturated.\nTransferring points from minimal curve [0,0,0,-253009,0] back to original curve [0,0,0,-4048144,0]\n\nGenerator 1 is [3977231486582278508189714401665075654349312369331552520997014769654828224:39740870795202171331157247562019395524949267412337171460766430406997360160:1928317088832685492020566294646267423214258259206809092654393913813973]; height 106.721376885791\n\nRegulator = 106.721376885791\n\nThe rank and full Mordell-Weil basis have been determined unconditionally.\n (1 seconds)}</span>"}︡
︠061cf9e1-50fd-43ce-93d5-2165b579abf5︠
get_systems('E2012.mwrank(options=\'-b 20 -x 12\')')
︡460a4937-9677-4d61-bdef-b47d357f4078︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left[\\hbox{mwrank}\\right]</span>"}︡
︠cfc0c40d-8381-4a59-bb65-1541a696675d︠
from sage.misc.citation import get_systems
︡59c0a05a-734e-4d4f-bfef-e847de0a3300︡︡
︠9ce26d71-dcac-4679-a34f-daaca0e5a308︠
E2012.analytic_rank()
︡fd3e6822-bbc6-428e-9269-36bc4a4d0da6︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}1</span>"}︡
︠8d9d5bd0-f1bd-4fd9-9531-fc1e838adf9b︠
P=E2012([3977231486582278508189714401665075654349312369331552520997014769654828224,39740870795202171331157247562019395524949267412337171460766430406997360160,1928317088832685492020566294646267423214258259206809092654393913813973]); P
︡9a973070-6137-45a7-89b4-866fa9f43f8b︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(\\frac{31953717079782403877426365136043401188458986438592}{15492409457317760025384676078081128557650708009} : \\frac{39740870795202171331157247562019395524949267412337171460766430406997360160}{1928317088832685492020566294646267423214258259206809092654393913813973} : 1\\right)</span>"}︡
︠8133f816-3515-45e8-b9dd-d54af9c5e066︠
P[1]^2-P[0]^3+2012^2*P[0]
︡21ad0a09-c801-4000-b3ce-8b20f915c12e︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}0</span>"}︡
︠141d5afe-2477-4d25-b7fa-d6e4c9b3d8b2i︠
%html
<p>The curve comes from "congruent number problem". 2012 is a congruent</p>
<p>number, and the right triangle associate with it is given by $a$, $b$ and $c$ below.</p>

︡c5f5f587-1a54-49ab-a0a5-f8fb67100e6a︡{"html": "<p>The curve comes from \"congruent number problem\". 2012 is a congruent</p>\n<p>number, and the right triangle associate with it is given by $a$, $b$ and $c$ below.</p>"}︡
︠c061fee7-012c-4c51-a08e-597fc7ff0293︠
a=P[1]/P[0]; a
︡3bd77797-40f3-4c38-aa16-5dcc20e95d79︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\frac{78366906299544891487468759852203246736490979835}{7842891235242432171391119745421505829682831394}</span>"}︡
︠880e355a-cd9c-4929-bc64-0ad721cbf1f4︠
b=2*2012*P[0]/P[1]; b
︡8ffa691b-8fe3-4b1b-9864-0dd5dbc6bac7︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\frac{62743129881939457371128957963372046637462651152}{155799018488160818066538289964618780788252445}</span>"}︡
︠631a998c-ee54-4985-a205-74897b299da5︠
c=(P[0]^2+2012^2)/P[1];c
︡e9293520-911f-449a-a368-cdff351fad94︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\frac{492238988669800304416700185089132231594105335620020162787295071274798563955460480753337934737}{1221914756560170125637172838524413935284120398357943486069854035440064998055224740843258330}</span>"}︡
︠18ff6496-271b-4b1f-b2ae-c3107097d4e4︠
a^2+b^2-c^2
︡83be1292-38a2-40ee-8311-19eb26d953b5︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}0</span>"}︡
︠bcf77e59-43b1-457a-a0ab-974c0c63ba1d︠
a*b/2
︡f8a6ad94-b2b8-4c9b-94e1-6c3fc7c78bc5︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}2012</span>"}︡
︠bde819a4-28b6-4282-87c2-8ec4a0bd226e︠
a+.0, b+.0, c+.0
︡1ca67130-4319-4f93-8432-3cf169961b6a︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(9.99209398026575, 402.718389953832, 402.842330880355\\right)</span>"}︡
︠3f0837b7-b73c-4c4e-8519-105ee602f586i︠
%html
<p>Let draw the triangle!</p>

︡c15e5691-a211-411a-bb1e-13d85f3b1920︡{"html": "<p>Let draw the triangle!</p>"}︡
︠f54d1977-16a7-41ff-9383-2028ada5cec1︠
from sage.plot.polygon import Polygon
︡a50c8045-275a-4cd4-abdf-e31225c45621︡︡
︠150c9238-bda5-4450-8781-02e1863bd357︠
P=polygon2d([[0,0], [a,0], [a,b]]); P
︡079bf0d0-efdb-4488-8586-73ec26d343fb︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠f30d839c-a72f-4005-9b74-4faaf7aed0a9i︠
%html
<p>Please note that the $x$ and $y$ axises. The true form of this right triangle is...</p>

︡82a40420-e52a-47b2-88df-e24d6868d4e9︡{"html": "<p>Please note that the $x$ and $y$ axises. The true form of this right triangle is...</p>"}︡
︠8e70fa1f-53d0-4ff5-ac06-48d9761b146d︠
P.set_aspect_ratio(1); P
︡e5c05bf8-492b-4921-a23d-59bdf2035bc5︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠5a25baa4-b9e7-44da-9987-81c0b6a7e3a8i︠
%html
<div style="color: #000000; background-image: initial; background-attachment: initial; background-origin: initial; background-clip: initial; background-color: #ffffff; background-position: initial initial; background-repeat: initial initial; margin: 8px;">
<p>S. Stein (Sage project leader) described the congruent number problem, Elliptic curves and Sage. See</p>
<p><a href="http://modular.math.washington.edu/simuw06/">http://modular.math.washington.edu/simuw06/</a></p>
<p>The author (I. K.) thanks Mr. S. Yokoyama (Kyushu) for bringing this documents to&nbsp;his attention.</p>
</div>

<h3>Cremona's table</h3>
<p>Install extra package:</p>
<p>install_package('<span style="font-family: monospace; white-space: pre;">database_cremona_ellcurve-20071019.p0')</span></p>

︡2f26a8ca-2c99-456f-9aa1-eb22d2a01d2f︡{"html": "<div style=\"color: #000000; background-image: initial; background-attachment: initial; background-origin: initial; background-clip: initial; background-color: #ffffff; background-position: initial initial; background-repeat: initial initial; margin: 8px;\">\n<p>S. Stein (Sage project leader) described the congruent number problem, Elliptic curves and Sage. See</p>\n<p><a href=\"http://modular.math.washington.edu/simuw06/\">http://modular.math.washington.edu/simuw06/</a></p>\n<p>The author (I. K.) thanks Mr. S. Yokoyama (Kyushu) for bringing this documents to&nbsp;his attention.</p>\n</div>\n\n<h3>Cremona's table</h3>\n<p>Install extra package:</p>\n<p>install_package('<span style=\"font-family: monospace; white-space: pre;\">database_cremona_ellcurve-20071019.p0')</span></p>"}︡
︠53cb296f-6471-44c0-a09b-72ab46a49ffa︠
CD=CremonaDatabase(); CD
︡53677f6b-93f6-4b7f-a3cf-b7c000aa0dfd︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\hbox{Cremona's database of elliptic curves}</span>"}︡
︠02160669-9809-4c65-b36f-eec29cdfd7f1︠
CD.random()
︡e36e9aa0-3e0b-41b0-856d-0c406f97dff3︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}y^2 = x^3 + x^2 + 208x - 2732 </span>"}︡
︠64d65cc6-787b-456d-8140-834f74d26c29i︠
%html
<h2>Elliptic Curves over real quadratic fields</h2>
<p>Mr. S. Yokoyama (Kyushu) asked me how to find a point on a curve</p>
<p>$y^2 = x^3 + 1728\varepsilon_d$, where $\varepsilon_d$ is the fundamental unit of a real quadratic $\mathbf{Q}(\sqrt{d})$ for</p>
<p>some specific $d$.</p>
<p>&nbsp;</p>

︡a2073e6e-5aed-485a-be0f-b1d385bbf70b︡{"html": "<h2>Elliptic Curves over real quadratic fields</h2>\n<p>Mr. S. Yokoyama (Kyushu) asked me how to find a point on a curve</p>\n<p>$y^2 = x^3 + 1728\\varepsilon_d$, where $\\varepsilon_d$ is the fundamental unit of a real quadratic $\\mathbf{Q}(\\sqrt{d})$ for</p>\n<p>some specific $d$.</p>\n<p>&nbsp;</p>"}︡
︠9e578147-e137-411d-b56d-81dd9729777b︠
Q43.<a>=QuadraticField(43); Q43
︡15b27794-c669-4521-aaa5-39d5f1e3e36f︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\Bold{Q}[\\sqrt{43}]/(\\sqrt{43}^{2} - 43)</span>"}︡
︠24466d7e-8885-475a-bb80-55bb542c3a99︠
eps = UnitGroup(Q43).fundamental_units()[0]; 1/eps
︡c48c88ec-5175-4b8e-96f7-3eaacab72eea︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}-531 \\sqrt{43} - 3482</span>"}︡
︠e5bb9726-8c69-4f80-8e33-8126ddf3a8e8︠
%gp
quadunit(4*43)
︡c2ffc0ff-094a-4c18-abac-8fc49a1c1dbe︡{"stdout": "3482 + 531*w"}︡
︠52ef513a-b452-4ec9-8ab4-2717e460b5c6︠
E = EllipticCurve(Q43, [0, 1728*eps]); E
︡3819a780-7729-4069-9c78-5eab9db183a3︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}y^2 = x^3 + \\left(917568 \\sqrt{43} - 6016896\\right) </span>"}︡
︠ff813765-e3d3-40f0-9bdf-2dbf6915fc96i︠
%html
<p>D. Simon's algebraic descent code (written in pari-gp) is included in Sage.</p>

︡84e98c24-db8a-4534-8564-6ac15258c17f︡{"html": "<p>D. Simon's algebraic descent code (written in pari-gp) is included in Sage.</p>"}︡
︠9584bdce-37cf-42b8-a977-d828e2949c3c︠
dscnt = E.simon_two_descent(verbose=1); dscnt
︡da694911-9d57-448b-bb8a-4f2351d03a72︡{"stdout": "courbe elliptique : Y^2 = x^3 + Mod(917568*y - 6016896, y^2 - 43)\npoints triviaux sur la courbe = [[1, 1, 0]]\n  ***   at top-level: ans=bnfellrank(K,[0,0,0,\n  ***                     ^--------------------\n  ***   in function bnfellrank: ...eqtheta,rnfeq,bbnf];rang=\n  ***   bnfell2descent_gen(b\n  ***   ^--------------------\n  ***   in function bnfell2descent_gen: ...riv,r=nfsqrt(nf,norm(zc))\n  ***   [1];if(DEBUGLEVEL_el\n  ***   ^--------------------\n  ***   array index (1) out of allowed range [none].\n"}︡{"stderr": "Traceback (most recent call last):\n  File \"<stdin>\", line 1, in <module>\n  File \"_sage_input_14.py\", line 10, in <module>\n    exec compile(u'open(\"___code___.py\",\"w\").write(\"# -*- coding: utf-8 -*-\\\\n\" + _support_.preparse_worksheet_cell(base64.b64decode(\"ZHNjbnQgPSBFLnNpbW9uX3R3b19kZXNjZW50KHZlcmJvc2U9MSk7IGRzY250\"),globals())+\"\\\\n\"); execfile(os.path.abspath(\"___code___.py\"))' + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"/tmp/tmpRMRIcu/___code___.py\", line 3, in <module>\n    exec compile(u'dscnt = E.simon_two_descent(verbose=_sage_const_1 ); dscnt' + '\\n', '', 'single')\n  File \"\", line 1, in <module>\n    \n  File \"/usr/local/sage2/local/lib/python2.6/site-packages/sage/schemes/elliptic_curves/ell_number_field.py\", line 277, in simon_two_descent\n    maxprob=maxprob, limbigprime=limbigprime)\n  File \"/usr/local/sage2/local/lib/python2.6/site-packages/sage/schemes/elliptic_curves/gp_simon.py\", line 114, in simon_two_descent\n    ans[2] = [inv_transform(F(P)) for P in ans[2]]\n  File \"/usr/local/sage2/local/lib/python2.6/site-packages/sage/schemes/elliptic_curves/ell_generic.py\", line 620, in __call__\n    return plane_curve.ProjectiveCurve_generic.__call__(self, *args, **kwds)\n  File \"/usr/local/sage2/local/lib/python2.6/site-packages/sage/schemes/generic/scheme.py\", line 222, in __call__\n    return self.point(args)\n  File \"/usr/local/sage2/local/lib/python2.6/site-packages/sage/schemes/generic/scheme.py\", line 256, in point\n    return self._point_class(self, v, check=check)\n  File \"/usr/local/sage2/local/lib/python2.6/site-packages/sage/schemes/elliptic_curves/ell_point.py\", line 303, in __init__\n    raise TypeError, \"Coordinates %s do not define a point on %s\"%(list(v),curve)\nTypeError: Coordinates [-377788/93025*a - 1952448/93025, -205379776/28372625*a - 1032512096/28372625, 1] do not define a point on Elliptic Curve defined by y^2 = x^3 + (917568*a-6016896) over Number Field in a with defining polynomial x^2 - 43"}︡
︠e0a4e01a-f122-450f-8783-98c836a94ac9︠
E(dscnt[2][0])
︡55e6c85b-7b8b-444a-9c7d-dbedf9c10481︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(-\\frac{377788}{93025} \\sqrt{41} - \\frac{1952448}{93025} : -\\frac{205379776}{28372625} \\sqrt{41} - \\frac{1032512096}{28372625} : 1\\right)</span>"}︡
︠cfa28edd-4d5d-4d18-90ac-631dd299c3b3︠
E.rank()
︡5e62371e-1c91-4ba0-99ce-73d86de15b68︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}2</span>"}︡
︠6f8a1b5b-8d47-4c3a-834e-f88ce21a7fbd︠
E.gens()
︡ee3ef731-cb1e-45c1-b68e-cc83e094b142︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left[\\left(-\\frac{377788}{93025} \\sqrt{41} - \\frac{1952448}{93025} : -\\frac{205379776}{28372625} \\sqrt{41} - \\frac{1032512096}{28372625} : 1\\right)\\right]</span>"}︡
︠84aadac8-c04d-401f-865b-526e64df1777︠
E(Q41)
︡c028c4af-5da9-4af1-96ba-701c8e845870︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\hbox{Abelian group of points on Elliptic Curve defined by y^2 = x^3 + (8640*a+55296) over Number Field in a with defining polynomial x^2 - 41}</span>"}︡
︠b661606b-94af-4ca5-ae54-76d3733ff38ci︠
%html
<h2 style="text-align: center;">Modular Forms</h2>

︡ffb227c1-26a0-4f41-aae7-a24dddb4f91b︡{"html": "<h2 style=\"text-align: center;\">Modular Forms</h2>"}︡
︠2858c010-9d2d-4ade-8fd2-a5dfbfb4d743︠
dimension_cusp_forms(Gamma0(11),2) # the dim of elliptic cusp forms of level 11, wt 2.
︡40954c62-eff8-45e3-89bb-a47bce16b05d︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}1</span>"}︡
︠312b0577-df04-4c0b-9a00-9abe373c1357︠
dimension_cusp_forms(Gamma0(1), 12) # the dim of elliptic cusp forms of level 1, wt 12.
︡0814fbd0-fdd7-4283-84f7-6d32fae54821︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}1</span>"}︡
︠10f44340-8155-422c-b1f9-c7a574d80253︠
S=CuspForms(Gamma0(11), 2); S
︡72c576fd-96b8-48a7-afd7-483912c788da︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\hbox{Cuspidal subspace of dimension 1 of Modular Forms space of dimension 2 for Congruence Subgroup Gamma0(11) of weight 2 over Rational Field}</span>"}︡
︠9f7d739a-03bb-4766-b9b9-0eee7961b7ed︠
S.basis() # Ramanujan's tau.
︡82aeb82f-09ad-402a-99c1-125d165b008e︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left[q - 2q^{2} - q^{3} + 2q^{4} + q^{5} + O(q^{6})\\right]</span>"}︡
︠5d5f0ffa-b923-4dbf-9686-5eba0e82ca1di︠
%html
<div style="color: #000000; background-image: initial; background-attachment: initial; background-origin: initial; background-clip: initial; background-color: #ffffff; background-position: initial initial; background-repeat: initial initial; margin: 8px;">
<p>Sage has huge amount of functions related to elliptic curves, modular forms of one variables and modular abelian varieties.</p>
<p>For those who interested in these features, the author recommend to read the section of Sage tutorial</p>
<p><a href="http://sagemath.org/doc/tutorial/tour_advanced.html#elliptic-curves">http://sagemath.org/doc/tutorial/tour_advanced.html#elliptic-curves</a>&nbsp;and&nbsp;W. Stein's book "</p>
<p><span id="btAsinTitle">Modular Forms, a Computational Approach (Graduate Studies in Mathematics)</span>", AMS 2007.</p>
</div>

<h2 style="text-align: center;">Misc: LaTeX output, File I/O</h2>

<p>Miscellaneous topics. The cell which begin with %latex is rendered by LaTeX.</p>
<p>One can store Sage objects into files and restore them.</p>

︡088eef27-46ef-4dd4-8f6d-b8a0b1e2e56a︡{"html": "<div style=\"color: #000000; background-image: initial; background-attachment: initial; background-origin: initial; background-clip: initial; background-color: #ffffff; background-position: initial initial; background-repeat: initial initial; margin: 8px;\">\n<p>Sage has huge amount of functions related to elliptic curves, modular forms of one variables and modular abelian varieties.</p>\n<p>For those who interested in these features, the author recommend to read the section of Sage tutorial</p>\n<p><a href=\"http://sagemath.org/doc/tutorial/tour_advanced.html#elliptic-curves\">http://sagemath.org/doc/tutorial/tour_advanced.html#elliptic-curves</a>&nbsp;and&nbsp;W. Stein's book \"</p>\n<p><span id=\"btAsinTitle\">Modular Forms, a Computational Approach (Graduate Studies in Mathematics)</span>\", AMS 2007.</p>\n</div>\n\n<h2 style=\"text-align: center;\">Misc: LaTeX output, File I/O</h2>\n\n<p>Miscellaneous topics. The cell which begin with %latex is rendered by LaTeX.</p>\n<p>One can store Sage objects into files and restore them.</p>"}︡
︠f0c510e6-fa72-4ca3-851a-1bfb9098add9︠
%latex
{\Large $\zeta(s) = \sum_{n=1}^{\infty}\frac{1}{n^s}$, $\Re(s)>1$.} % LaTeX formatting.
︡cf072473-03d8-48a0-a266-6a3ce6150304︡︡
︠bdd1b7ec-4217-4d67-a785-319c56560728︠
latex('QQ')
︡7580cb5d-888b-4b49-be3e-4365e7e8f976︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\hbox{\\hbox{QQ}}</span>"}︡
︠2b547cf9-cad5-4dbf-b517-93fa3f4b3bc0i︠
%html
<p>Store the results of computation into a file.</p>

︡b08c562c-122f-4a04-bde0-f60df00f3b37︡{"html": "<p>Store the results of computation into a file.</p>"}︡
︠308126b7-8b64-461c-99cb-d5b76961a24d︠
S.dump(SAGE_TMP+'Level11wt2CuspForms')
︡dab5db3d-8aa5-4a4d-bd8b-dbda80397fd4︡︡
︠207329b8-636d-4e65-a646-967bd138c9dai︠
%html
<p>Load stored computation and compare it with original one.</p>

︡c399b4dd-7329-443c-843d-115fa4d25d4d︡{"html": "<p>Load stored computation and compare it with original one.</p>"}︡
︠870341b9-5f0a-45bf-a196-3bce9b8ccc6f︠
S == load(SAGE_TMP+'Level11wt2CuspForms')
︡954ad54e-904d-4ebd-bf91-a701ef4cb9a2︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}{\\rm True}</span>"}︡
︠4951c1b8-e71e-4311-964a-caf745910780i︠
%html
<h2 style="text-align: center;">Thats's all!</h2>
<p>Thank you for your attention.</p>

<p>The list of Sage's extra-packages. These are not installed by default but can be installed by</p>
<p>install_package() command.</p>

︡d03a3efa-c4b2-4234-99ec-569ca84fb45f︡{"html": "<h2 style=\"text-align: center;\">Thats's all!</h2>\n<p>Thank you for your attention.</p>\n\n<p>The list of Sage's extra-packages. These are not installed by default but can be installed by</p>\n<p>install_package() command.</p>"}︡
︠12a0434c-a082-4ea6-a360-3915c175aaae︠
for d in optional_packages():
    print d
︡c686d38e-a537-40d1-96ad-89269cb03ad2︡{"stdout": "['database_cremona_ellcurve-20071019.p0', 'database_gap-4.4.12.p0', 'database_jones_numfield-v4', 'database_odlyzko_zeta', 'gap_packages-4.4.12.p0']\n['ace-5.0.p0', 'biopython-1.55.p0', 'cbc-2.3.p2', 'cunningham_tables-1.0', 'database_kohel-20060803', 'database_sloane_oeis-2005-12', 'database_stein_watkins_mini.p0', 'database_symbolic_data-20070206', 'extra_docs-20070208', 'fricas-1.0.9', 'fricasaldor-1.0.9', 'gdbm-1.8.3', 'ginv-1.9-20080723', 'glpk-4.42.p0', 'gmpy-1.0.1', 'gnuplotpy-1.8', 'graphviz-2.16.1.p0', 'guppy-0.1.8', 'java3d-20070901', 'jsmath_image_fonts-1.4.p3', 'kash3-2008-07-31', 'knoboo-20080411', 'libcocoa-0.9930', 'libogg-1.1.4', 'libtheora-1.1.1', 'lie-2.2.2.p3', 'lrs-4.2b.p1', 'mpc-0.8.3-dev-svn793', 'mpi4py-1.1.0', 'nauty-24', 'nzmath-1.0.0', 'openmpi-1.1.4', 'openssl-1.0.0.p0', 'p_group_cohomology-2.0', 'phc-2.3.53.p0', 'pycryptoplus-20100809-git', 'pyopenssl-0.8', 'pyx-0.10', 'qhull-2010.1', 'sage-mode-0.6', 'trac-0.11.5.p0', 'valgrind-3.3.1']"}︡
